require 5.004;
use strict;
#------------------------------------------------------------------------------
# Authrization
#						(C)2005-03 nabe / nabe@abk.nu
#------------------------------------------------------------------------------
use Satsuki::Auth ();
package Satsuki::Auth;
my $_SALT = '5hLPQEDcY8mZKFbluVgrvqiSCHWaOGeTUMsRNnJXfIk/j4oBpdA29tx67wy3z.10';
###############################################################################
# ǧ롼
###############################################################################
#------------------------------------------------------------------------------
# 
#------------------------------------------------------------------------------
sub login {
	my ($self, $id, $pass, $force_auth) = @_;
	my $ROBJ   = $self->{ROBJ};
	my $userdb = $self->load_userdb();

	if (! $self->{exists_user} && $self->{start_up}) {	# ̵ﾵǧ
		$self->{ok}    = 1;
		$self->{id}    = "root*";
		$self->{name}  = "root*";
		return 'auth (no exist user)';
	}

	my $udata = $userdb->{$id};
	if ($id eq '' || $id =~ /\W/ || !defined $udata) {	# uid ¸ߤʤ
		$ROBJ->message('Username or password incorrect');
		return;
	}
	# ԥȤ򻲾
	my $fail_file = $self->{dir} . $id . "-fail" . $self->{file_ex};
	my $lines = $ROBJ->fread_lines_no_error($fail_file);
	my $fails = $lines->[0];
	my $tm    = $lines->[1];
	# ַвᤷ顢ԥ󥿤 0 ˽
	if ($tm + $self->{fail_minute}*60 < $ROBJ->{TM}) { $fails=0; }
	if ($fails > $self->{fail_count}) {
		$ROBJ->message('Too many failed. Please retry in %d minutes', $self->{fail_minute});
		return;
	}
	if (!$force_auth && !$self->check_pass($udata->{pass}, $pass)) {
		$ROBJ->fwrite_lines($fail_file, ($fails+1) . "\n$ROBJ->{TM}");
		$ROBJ->message('Username or password incorrect');
		return;
	}
	if ($udata->{disable}) {
		$ROBJ->message('This account is disable');
		return;
	}

	# ˥Ѥξ硢
	if ($self->{id} && !$self->{multisession}) {
		$self->logout();
	}

	# 
	$self->{ok}    = 1;
	$self->{id}    = $udata->{id};
	$self->{admin} = $udata->{admin};	# Ը
	$self->{name}  = $udata->{name};
	$self->{info}  = $udata->{info};

	# åID¸
	my $sid  = $self->generate_SessionID();
	my $file = $self->{dir} . $id . $self->{file_ex};
	if ($self->{multisession}) {
		$self->{_sid} = $sid;
		$ROBJ->fappend_lines($file, "$sid\t$ROBJ->{TM}\n");
	} else {
		$ROBJ->fwrite_lines ($file, "$sid\t$ROBJ->{TM}\n");
	}
	return $sid;
}

#------------------------------------------------------------------------------
# åξǧ
#------------------------------------------------------------------------------
sub session_auth {
	my ($self, $id, $session_id) = @_;
	my $ROBJ   = $self->{ROBJ};
	my $userdb = $self->load_userdb();

	# 桼̤Ͽ˼ưǧ
	#     $self->{exists_user}  $self->set_userdb( ) ꤵ
	if (! $self->{exists_user} && $self->{start_up}) {
		$self->{ok}      = 1;
		$self->{id}      = "root*";
		$self->{name}    = "root*";
		$self->{admin}   = 1;	# Ը
		$self->{auto}    = 1;	# ̵ﾵǧե饰
		$ROBJ->message('No exists user data. You should add new user before use this');
		return 2;
	}
	if ($id eq 'root*') { return; }

	$id =~ s/\W//g;		# ɻ
	if ($id eq '' || $session_id eq '') { return; }

	my $file  = $self->{dir} . $id . $self->{file_ex};
	my $lines = $ROBJ->fread_lines_cached_no_error($file);
	if (! ref $lines) { return; }

	# åξǧ
	my $expires = $self->{expires};
	my $limit   = $ROBJ->{TM} - $expires;
	my $auth;
	my $change;
	foreach(@$lines) {
		my ($save_sid, $tm) = split('\t', $_, 2);
		if (0<$expires && $limit>$tm) {	# ڤ
			$_ = undef;
			$change=1;
		} elsif ($save_sid eq $session_id) { $auth=1; }
	}
	if ($change) {	# ڤ
		if ($self->{multisession}) {
			my @ary = grep { defined($_) } @$lines;
			$ROBJ->fwrite_lines($file, \@ary);
		} else {
			$ROBJ->file_delete($file);
		}
	}
	# ǧ
	if (! $auth) { return; }

	# 
	## $ROBJ->touch($file);		# 򤺤餹
	my $userdb2 = $self->load_userdb();
	my $udata   = $userdb2->{$id};
	if ($udata->{disable}) { return; }	# ̵桼
	$self->{ok}    = 1;
	$self->{id}    = $udata->{id};
	$self->{admin} = $udata->{admin};	# Ը
	$self->{name}  = $udata->{name};
	$self->{info}  = $udata->{info};
	if ($self->{multisession}) {
		$self->{_sid} = $session_id;
	}

	return 1;
}

#------------------------------------------------------------------------------
# IDꤷƥǧ
#------------------------------------------------------------------------------
sub force_auth {
	my ($self, $id) = @_;
	my $ROBJ   = $self->{ROBJ};
	my $userdb = $self->load_userdb();
	my $udata = $userdb->{$id};
	if ($id eq '' || $id =~ /\W/ || !defined $udata) { return 1; }
	if ($udata->{disable}) {
		$ROBJ->message('This account is disable');
		return 2;
	}
	# 
	$self->{ok}    = 1;
	$self->{id}    = $udata->{id};
	$self->{admin} = $udata->{admin};	# Ը
	$self->{name}  = $udata->{name};
	$self->{info}  = $udata->{info};
	return 0;
}

#------------------------------------------------------------------------------
# 
#------------------------------------------------------------------------------
sub logout {
	my ($self) = @_;
	my $ROBJ = $self->{ROBJ};
	my $id   = $self->{id};

	$id =~ s/\W//g;
	if ($id eq '') { return; }

	# 
	undef $self->{ok};
	undef $self->{id};
	undef $self->{name};
	undef $self->{admin};
	undef $self->{info};

	# åξõ
	my $file  = $self->{dir} . $id . $self->{file_ex};
	if ($self->{multisession} && !$self->{all_logout}) {
		my $this_sid = $self->{_sid};
		if ($this_sid eq '') { return; }

		my $lines = $ROBJ->fread_lines_cached_no_error($file);
		if (! ref $lines) { return; }

		my $change;
		foreach(@$lines) {
			my ($sid, $tm) = split('\t', $_, 2);
			if ($sid eq $this_sid) {
				$_=undef; $change=1; last;
			}
		}
		if (! $change) { return; }
		my @ary = grep { defined($_) } @$lines;
		$ROBJ->fwrite_lines($file, \@ary);
	} else {
		$ROBJ->file_delete($file);
		$ROBJ->file_delete($self->{dir} . $id . "-fail" . $self->{file_ex});
	}
	return ;
}

###############################################################################
# ӥ롼
###############################################################################
#-------------------------------------------------------------------------------
# 桼ξ
#-------------------------------------------------------------------------------
sub get_userinfo {
	my ($self, $uid) = @_;
	my $ROBJ = $self->{ROBJ};
	# if (! $self->{admin} && $uid ne $self->{id}) { $ROBJ->message('Operation not permitted'); return 1; }

	my $h = $self->load_userdb() ->{$uid};
	if (ref $h ne 'HASH') { return undef; }

	my %h = %$h;
	undef $h{pass};
	return $h;
}

###############################################################################
# ֥롼
###############################################################################
#------------------------------------------------------------------------------
# 桼ǡ١Υ
#------------------------------------------------------------------------------
sub load_userdb {
	my ($self, $load_force) = @_;

	if (!$load_force && defined $self->{userdb}) {	# ˥ɺ
		return $self->{userdb};
	}
	my $ROBJ = $self->{ROBJ};

	# եɤ߹ߡǡ١˥å
	my $file = $self->{userdb_file};
	if (substr($file,0,1) ne '/') { $file = $self->{dir} . $file; }
	if ($file eq '') {
		$ROBJ->error("[auth] Don't set user database file");
		return $self->{userdb} = {};
	}
	$self->{userdb} = $self->set_userdb( $ROBJ->fread_lines_cached_no_error( $file ) );

	# 桼ǡ١ plain pass ΰŹ沽
	#     $self->{exist_plain}  $self->set_userdb( ) ꤵ
	if ($self->{exist_plain}) { $self->edit_userdb(); }
	return $self->{userdb};
}

#------------------------------------------------------------------------------
# 桼ǡβϤ
#------------------------------------------------------------------------------
sub set_userdb {
	my ($self, $lines) = @_;
	my $userdb  = {};	# Υϥå
	foreach(@$lines) {
		chomp($_);
		my %h;
		($h{id}, $h{pass}, $h{admin}, $h{name}, $h{disable}, $h{info}) = split(/\t/, $_);
		if ($h{id} eq '' || $h{name} eq '') { next; }

		# plain pass ξ硢crypt
		if (substr($h{pass}, 0, 6) eq 'plain:') {
			$h{pass} = $self->encrypt_pass(substr($h{pass}, 6));
			$self->{exist_plain} = 1;
		} elsif ($h{pass} eq '*') {
			$h{disable} = 1;
		}
		$userdb->{$h{id}} = \%h;
		$self->{exists_user} = 1;
	}
	return $userdb;
}

#------------------------------------------------------------------------------
# åID
#------------------------------------------------------------------------------
sub generate_SessionID {
	my ($self) = @_;
	my $sid;
	my $salt = $self->{ROBJ}->{Salt64chars} || $_SALT;
	my $base = $ENV{UNIQUE_ID} . $ENV{REMOTE_ADDR};
	my $sid  = $self->{ROBJ}->make_secure_id($base, int(rand(8192)), 8);
	for(my $i=0; $i<12; $i++) {
		$sid .= substr($salt, int(rand(256+ord(substr($base,$i,1))*256) % 64), 1);
	}
	$sid =~ tr|/|-|;	# hack
	return $sid;
}


#------------------------------------------------------------------------------
# ѥɤǧڤ
#------------------------------------------------------------------------------
sub check_pass {
	my ($self, $crypted_pass, $plain_pass) = @_;
	if (crypt($plain_pass, $crypted_pass) eq $crypted_pass) { return 1; }	# auth
	return 0;
}

1;	# ޤʤ
