#!/usr/local/bin/perl
require 5.004;
use strict;
#------------------------------------------------------------------------------
# ǡݡ for ϤƤʷ(xml)
#                                                   (C)2006 nabe / nabe@abk.nu
#------------------------------------------------------------------------------
package Satsuki::Diary::ExportHatena;
###############################################################################
# ܽ
###############################################################################
#------------------------------------------------------------------------------
# ڥ󥹥ȥ饯
#------------------------------------------------------------------------------
sub new {
	my $class = shift;
	my $self  = {};
	bless($self, $class);		# $self 򤳤Υ饹ȴϢդ
	$self->{ROBJ}  = shift;

	return $self;
}

#------------------------------------------------------------------------------
# ڥǥȥ饯
#------------------------------------------------------------------------------
sub DESTROY {
}
###############################################################################
# ǡݡ
###############################################################################
#------------------------------------------------------------------------------
# ϤƤʷΥǡݡ
#------------------------------------------------------------------------------
sub export {
	my ($self, $skelton, $logs, $option) = @_;
	my $ROBJ = $self->{ROBJ};

	# ʸѴ
	my $system_coding = $ROBJ->{System_coding};
	my $output_coding = 'UTF-8';
	my $jcode;
	if ($system_coding ne $output_coding) {
		$jcode = $ROBJ->loadpm('Jcode');
		if ($option->{hatena_utf8bug}) { $jcode->{EXTRA_UTF8_PATCH} = 0; }
	}

	# ɸѡν
	my $diary_obj = $option->{diary_obj};
	$ROBJ->call( $diary_obj->{parser_skelton_dir} . 'default_no_br' );
	my $parser_obj = $diary_obj->{parser};		# ɤѡΥ֥
	if (ref($parser_obj)) {
		$parser_obj->{thisurl}  = '';
		$parser_obj->{indent}   = '';
		$parser_obj->{no_div_section}    = 1;	# <div class="section"></div>Ϥʤ
		$parser_obj->{escape_no_dencode} = 1;	# [] () ʤɤΥפᤵʤ
		$self->{default_parser} = $parser_obj;
	}

	# 
	my $html_mode = $option->{hatena_html};		# ɸѡƥȤHTMLǽ
	my $title2h3  = $option->{hatena_title};
	my $with_time = $option->{hatena_with_time};
	#---------------------------------------------------------------------
	# βϤ¸
	#---------------------------------------------------------------------
	foreach (@$logs) {
		my $yyyymmdd = $_->{yyyymmdd};
		$_->{year} = substr($yyyymmdd, 0, 4);
		$_->{mon}  = substr($yyyymmdd, 4, 2);
		$_->{day}  = substr($yyyymmdd, 6, 2);
		#-------------------------------------------------------------
		# ʸѴ
		#-------------------------------------------------------------
		my $parser = $_->{parser};
		if ($parser eq 'tdiary')      { $self->tdiary2hatena ($_, $option); }
		elsif ($html_mode)            { $self->html2hatena   ($_, $option); }
		elsif ($parser =~ /^default/) { $self->default2hatena($_, $option); }
		else                          { $self->html2hatena   ($_, $option); }

		# ȥ򸫽Фǽ
		if ($title2h3 && $_->{title} ne '') {
			my $t;
			if ($with_time) { $t="$_->{tm}*"; }
			$_->{body} = "*$t$_->{title}\n" . $_->{body};
		}
		# ξ硢ʸ򥳥Ȥ
		if (! $_->{enable}) {
			$_->{body} =~ s/-->/--&gt;/g;
			$_->{body} = "<!--\n$_->{body}\n-->";
		}
		#-------------------------------------------------------------
		# ȥμ¹
		#-------------------------------------------------------------
		$ROBJ->{tmp} = $_;
		my $day = $ROBJ->execute( $skelton );

		#-------------------------------------------------------------
		# 
		#-------------------------------------------------------------
		my $str = $ROBJ->chain_array( $day );
		if ($jcode) {
			$jcode->from_to(\$str, $system_coding, $output_coding);
		}
		print $str;
	}
	return 0;
}

###############################################################################
# ˡС
###############################################################################
#------------------------------------------------------------------------------
# ɸѡ  ϤƤʥ
#------------------------------------------------------------------------------
# last update and tested : 2006/08/01
sub default2hatena {
	my ($self, $h, $option) = @_;
	my $default_parser = $self->{default_parser};
	if (! $default_parser) {
		return $self->html2hatena( $h, $option );
	}

	my $parser = $h->{parser};
	my $text = "\n" . $h->{_text} . "\n";		# 

	# * θФ
	my @atags;
	my $x;
	if ($option->{hatena_title}) { $x='*'; }	# *  ** Ѵ
	$text =~ s/\e//g;
	# super pre ֥å
	$text =~ s/((?:\G|\n)(>\|\w*\|(\#)?)[\w\-]*\n(.*?\1?\n\|\|<\n))/
		if($3 eq '#') { $1 }
		else { push(@atags, "$2\n$4"), "\n\$\e$#atags\$" }/seg;
	# 
	$text =~ s/(<!--.*?-->)/push(@atags, $1), "\$\e$#atags\$"/seg;
	# Ƭ :: Υ饹
	$text =~ s/\n::[\w\-]+//g;
	$text =~ s/\n\|::[\w\-\|]+//g;	# table 饹

	# Ƭ * = ¸
	$text =~ s/\n([\*\=])/\n $1/g;
	# ĥơ֥뵭ˡȤƤʤ
	if ($text !~ /\|\s*[<>\~\_]\s*\|/) {
		$text =~ s/\n\|([^<\|])/\n |$1/g;
	}
	# ĥꥹȵˡȤƤʤ
	if (index($text, "\n-\n")<0 && index($text, "\n+\n")<0) {
		$text =~ s/\n([\-\+])/\n $1/g;
	}
	# ĥꥹȵˡȤƤʤ
	if (index($text, "\n::\n")<0) {
		$text =~ s/\n:/\n :/g;
	}
	# (( )) 򥨥
	$text =~ s/\(\(/push(@atags, '(('), "\$\e$#atags\$"/eg;


	# ѡ̤
	$text = $default_parser->text_parser( $text );

	# ǥȤν
	$text =~ s/\n\t*/\n$1/g;
	# pre, table, ul֥å
	$text =~ s/\n(<(pre|table|ul|ol|dl)[^>\n]*>)\n/\n>$1\n/g;
	$text =~ s/\n(<\/(pre|table|ul|ol|dl)>)\n/\n$1<\n/g;

	# Ф
	$text =~ s/\$\e(\d+)\$/$atags[$1]/g;

	$h->{body} = substr($text, 1);	# ǽβԽ
	if ($parser eq 'default_no_br') {
		$h->{body} = "><div>\n$h->{body}\n</div><";	# Τ p ߵˡ
	}
	return ;
}

#------------------------------------------------------------------------------
# tdiary  ϤƤʥ
#------------------------------------------------------------------------------
sub tdiary2hatena {
	my ($self, $h, $option) = @_;
	my $title_mark = '*';
	if ($option->{hatena_title}) { $title_mark='**'; }

	my @lines = split("\n", $h->{_text});
	my @ary;
	my @section;
	my $in_section = 0;
	push(@lines, '');	# ɬsectionĤ뤿ղ
	foreach(@lines) {
		$_ .= "\n";
		my $s1 = substr($_, 0, 1);
		my $s2 = substr($_, 0, 2);
		# amazonб
		$_ =~ s/<%=(isbn.*?)%>/&amazon($1)/eg;

		#----------------------------------------------------
		# Ǥ
		#----------------------------------------------------
		if ($in_section) {
			if ($_ eq "\n") {		# ν
				if ($in_section < 0) {		# <p> ػߥ
					unshift(@section, "><div>\n");	# <p>
					push   (@section, "</div><\n");	# <p>
				}
				foreach(@section) { push(@ary, $_); }
				push(@ary, "\n");
				@section = ();
				$in_section=0;
				next;
			}
			# Ƭˡ escape
			$_ =~ s/^([\-\+\*|:=])/ $1/;
			push(@section, $_);
			# '<'ǻϤޤԤ硢<p>ʤ
			if (ord($s1) == 0x3c) { $in_section=-1; }
			next;
		}
		#----------------------------------------------------
		# 
		#----------------------------------------------------
		if ($_ eq "\n") { next; }
		#----------------------------------------------------
		# λϤޤ
		#----------------------------------------------------
		$in_section = 1;
		if ($s1 eq '<' && $s2 ne '<<') {	# tagʥ(pػ)
			$in_section = -1;
			push(@section, $_);	# Ѥ
			next;
		}
		if ($s1 eq ' ') {		# ƬȾѥڡ
			$_ = substr($_, 1);
			push(@section, $_);
			next;
		}
		if ($s2 eq '') {		# Ƭѥڡ
			$_ = substr($_, 2);
			push(@section, $_);
			next;
		}
		# ʳϡ󥿥ȥ
		if ($s2 eq '<<') {		# tagʥ֥ȥ
			$_ = substr($_, 1);
			push(@ary, "$title_mark$_\n");
			next;
		}
		push(@ary, "$title_mark$_\n");
	}
	$h->{body} = join('', @ary);
	return ;
}

#------------------------------------------------------------------------------
# amazonν񤭴
#------------------------------------------------------------------------------
sub amazon {
	my $tag = shift;
	if ($tag =~ /^isbn_image.*?"(.*?)"/)   { return "[isbn:$1:image]";    }
	if ($tag =~ /^isbn.*"(.*?)".*"(.*?)"/) { return "[isbn:$1:title=$2]"; }
	if ($tag =~ /^isbn.*"(.*?)"/)          { return "[isbn:$1]";          }
	return '';
}

#------------------------------------------------------------------------------
# ¾ν  ϤƤʷ
#------------------------------------------------------------------------------
sub html2hatena {
	my ($self, $h, $option) = @_;
	my $diary_obj = $option->{diary_obj};
	$diary_obj->text_split_for_mt( $h );

	my $body = $h->{body};
	# ݴ
	my @tags;
	$body =~ s/\x01//g;
	if ($h->{ex_body} ne '') {
		push(@tags, "=====");
		$body .= "\n<\x01$#tags>\n" . $h->{ex_body};
	}
	$body =~ s/(<\w([^>"']|[=\s\n]".*?"|[=\s\n]'.*?')*?>)/push(@tags, $1), "<\x01$#tags>"/esg;
	my @ary = split("\n", $body);
	# ϤƤʵˡΥ
	foreach(@ary) {
		# Ƭˡ escape
		$_ =~ s/^([\-\+\*|:=])/ $1/;
		$_ =~ s/([\[\]])/'&#' . ord($1) . ';'/eg;
		$_ =~ s/\(\((.*?)\)\)/(&#40;$1&#40;)/g;
	}
	# 
	$body = join("\n", @ary);
	$body =~ s/<\x01(\d+)>/$tags[$1]/g;
	# CONVERT BREAKS ν
	if (! $h->{convert_breaks}) {
		$body = "><div>\n$body\n</div><";	# p ߵˡ
	}
	$h->{body} = $body;

	return ;
}

1;
