#!/usr/local/bin/perl
require 5.004;
use strict;
#------------------------------------------------------------------------------
# ǡݡ for JUGEM
#                                                   (C)2006 nabe / nabe@abk.nu
#------------------------------------------------------------------------------
package Satsuki::Diary::ExportJUGEM;
use Time::Local;
###############################################################################
# ܽ
###############################################################################
#------------------------------------------------------------------------------
# ڥ󥹥ȥ饯
#------------------------------------------------------------------------------
sub new {
	my $class = shift;
	my $self  = {};
	bless($self, $class);		# $self 򤳤Υ饹ȴϢդ
	$self->{ROBJ}  = shift;

	return $self;
}

#------------------------------------------------------------------------------
# ڥǥȥ饯
#------------------------------------------------------------------------------
sub DESTROY {
}
###############################################################################
# ǡݡ
###############################################################################
#------------------------------------------------------------------------------
# JUGEMΥǡݡ
#------------------------------------------------------------------------------
sub export {
	my ($self, $skelton, $logs, $option) = @_;
	my $ROBJ = $self->{ROBJ};

	# ʸѴ
	my $system_coding = $ROBJ->{System_coding};
	my $output_coding = 'UTF-8';
	my $jcode;
	if ($system_coding ne $output_coding) {
		$jcode = $ROBJ->loadpm('Jcode');
	}

	# إå
	{
		my $header = $ROBJ->chain_array( $option->{header} );
		if ($jcode) {
			$jcode->from_to(\$header, $system_coding, $output_coding);
		}
		print $header;
	}

	# 
	my $diary_obj  = $option->{diary_obj};
	my $sb_mode    = $option->{sb_mode};	# Serene Bach ĥե饰
	my $force_ymd  = $option->{force_ymd};
	#---------------------------------------------------------------------
	# βϤ¸
	#---------------------------------------------------------------------
	foreach (@$logs) {
		#-------------------------------------------------------------
		# ǡù
		#-------------------------------------------------------------
		if ($_->{enable}) { $_->{status}='Publish'; } else { $_->{status}='Draft'; }	# for sb

		# ղù
		my $yyyymmdd = $_->{yyyymmdd};
		my $year = substr($yyyymmdd, 0, 4);
		my $mon  = substr($yyyymmdd, 4, 2);
		my $day  = substr($yyyymmdd, 6, 2);
		my $ymd_utc;
		eval { $ymd_utc = Time::Local::timegm(0, 0, 0, $day,$mon-1,$year); };
		my $tm = $_->{tm};		# ꤷƤ
		if ($ymd_utc && ($force_ymd || $tm-$ymd_utc>86400)) {
			# 00:00:00 ʤƥबΤ, pkey ­
			$tm = $ymd_utc + int($_->{pkey});
		}
		$_->{tm} = $tm;

		#-------------------------------------------------------------
		# ʸù
		#-------------------------------------------------------------
		$diary_obj->text_split_for_mt( $_ );
		# $_->{text}  $_->{parser} 
		# $_->{convert_breaks}, $_->{body}, $_->{ex_body}
		# ŬڤꤷƤ

		# Ԥִ
		if (! $sb_mode && $_->{convert_breaks}) {
			$_->{body}    =~ s|\n|<br />\n|g;
			$_->{ex_body} =~ s|\n|<br />\n|g;
		}

		#-------------------------------------------------------------
		# ȥμ¹
		#-------------------------------------------------------------
		$ROBJ->{tmp} = $_;
		my $day = $ROBJ->execute( $skelton );

		#-------------------------------------------------------------
		# 
		#-------------------------------------------------------------
		my $str = $ROBJ->chain_array( $day );
		if ($jcode) {
			$jcode->from_to(\$str, $system_coding, $output_coding);
		}
		print $str;
	}
	return 0;
}

###############################################################################
# ȥ֥롼
###############################################################################
#------------------------------------------------------------------------------
# <![CDATA[]]>Ѥ˥ǡ򥨥פ
#------------------------------------------------------------------------------
sub cdata_escape {
	my $self = shift;
	foreach(@_) {
		$_ =~ s/\]\]>/]]&gt;/g;
	}
	return $_[0];
}


#------------------------------------------------------------------------------
# <br>  \n ѹ
#------------------------------------------------------------------------------
sub br2lf {
	my $self = shift;
	foreach(@_) {
		$_ =~ s/\n//g;
		$_ =~ s/<br>/\n/g;
	}
	return $_[0];
}

#------------------------------------------------------------------------------
# ॾʸ +09:00 
#------------------------------------------------------------------------------
sub tz2string {
	my ($self, $tz) = @_;
	$tz = int($tz*60);
	my $hour = int($tz/60);
	my $min  = $tz - $hour*60;
	if ($tz < 0) { return sprintf("%02d:%02d", $hour, $min); }
	return sprintf("+%02d:%02d", $hour, $min);;
}



1;
