////////////////////////////////////////////////////////////////////////////////
// ֥ȤΥꥵץ (Javascript) Ver.1.01
//   Copyright (C) 2008 ꤫/꤫
////////////////////////////////////////////////////////////////////////////////

/* provided objects/methods
 *   var isIE
 *   var resizable (object)
 *   function resizableById(id, maxheight, maxwidth, minheight, minwidth)
 *   function resizableByObj(obj, maxheight, maxwidth, minheight, minwidth, name)
 *   function resizableAllTextarea(maxheight, maxwidth, minheight, minwidth)
 *   function resizableAllTextbox(maxheight, maxwidth, minheight, minwidth)
 */

var isIE = /*@cc_on ! @*/ false;
var isIE8 = (isIE<8 && 0<appVer.indexOf("Trident/")) ? true : false;
var isOpera = navigator.userAgent.indexOf("Opera") != -1;
var isGecko = navigator.userAgent.indexOf("Gecko") != -1;

////////////////////////////////////////////////////////////////////////////////
var resizable = {
	debug         : false,
	dragdirection : null,
	draginfo      : null,
	dragobj       : null,
	gripsize      : 6,
	gripshift     : -2,
	targets       : new Array(),
	getPosition: function (obj){
		if(obj == undefined)
			return [-1,-1,-1,-1];

		var height = obj.offsetHeight;
		if(height == undefined)
			height = obj.clientHeight;

		var width = obj.offsetWidth;
		if(width == undefined)
			width = obj.clientWidth;

		var curX = obj.offsetLeft;
		var curY = obj.offsetTop;
		var parent = obj.offsetParent;
		var style;
		while (parent) {
			curX += parent.offsetLeft;
			curY += parent.offsetTop;
			if (!isOpera) {
				style = this.getStyle(parent);
				curX += (parseInt(style.borderLeftWidth) || 0);
				curY += (parseInt(style.borderTopWidth) || 0);
			}
			parent = parent.offsetParent;
		}

	    return [curX,curY,width,height];
	},
	getStyle: function(obj) {
		return obj.currentStyle || (document.defaultView && document.defaultView.getComputedStyle(obj, '')) || null;
	},

	reg           : /^grip(H|V|X)_(.*)$/,
	dragstart: function (event){
		if(resizable.dragobj) return;

		var target = event.srcElement || event.target;
		var res = resizable.reg.exec(target.id);

		resizable.dragdirection = res[1];
		resizable.draginfo = resizable.targets[res[2]];
		resizable.dragobj  = resizable.draginfo.obj; //document.getElementById(res[2]);

		// ɥåΥѹ
		switch(resizable.dragdirection){
			case 'H': document.body.style.cursor = 'w-resize';  break;
			case 'V': document.body.style.cursor = 'n-resize';  break;
			case 'X': document.body.style.cursor = 'se-resize'; break;
		}

		// ɥåΥ٥Ȥɲ
		resizable.addEvent(document.body, 'mousemove', resizable.dragging);
		resizable.addEvent(document.body, 'mouseup',   resizable.dragend);

		// Firefox3Operaǥɥå˥ƥȤ򤵤ƤޤΤɻ
		if (isGecko || isOpera) event.preventDefault();
	},
	dragend: function(event){
		// ᤹
		document.body.style.cursor = 'auto';

		// ɥåΥ٥Ȥ
		resizable.delEvent(document.body, 'mousemove', resizable.dragging);
		resizable.delEvent(document.body, 'mouseup',   resizable.dragend);

		resizable.resetpos();
		resizable.dragobj = null;
	}, 

	// ֥ȤΥꥵ
	dragging : function(event){
		if(resizable.dragobj == null){
			resizable.dragend();
			return false;
		}

		if(resizable.dragdirection == 'H' || resizable.dragdirection == 'X'){
			var tmp = event.clientX - resizable.draginfo.base[0] - resizable.gripsize;
			var style = resizable.dragobj.currentStyle || document.defaultView.getComputedStyle(resizable.dragobj, '');
			tmp -= (parseInt(style.paddingRight) || 0);
			if(isIE){
				tmp += 4;
			}else if(isGecko || isOpera){
				if(document.compatMode == "BackCompat") tmp += 8;
				else tmp += (parseInt(style.borderRightWidth) || 0);
			}
			if(window.pageXOffset)                       tmp += window.pageXOffset;
			else if(document.documentElement.scrollLeft) tmp += document.documentElement.scrollLeft;
			else if(document.body.scrollLeft)            tmp += document.body.scrollLeft;
			if(tmp < resizable.draginfo.min[0]) tmp  = resizable.draginfo.min[0];
			if(resizable.draginfo.max[0] > 0 && tmp > resizable.draginfo.max[0]) 
			                                    tmp  = resizable.draginfo.max[0];
			resizable.dragobj.style.width = tmp + 'px';
		}
		if(resizable.dragdirection == 'V' || resizable.dragdirection == 'X'){
			var tmp = event.clientY - resizable.draginfo.base[1] - resizable.gripsize;
			var style = resizable.dragobj.currentStyle || document.defaultView.getComputedStyle(resizable.dragobj, '');
			tmp -= (parseInt(style.paddingBottom) || 0);
			if(isIE){
				tmp += 4;
			}else if(isGecko || isOpera){
				if (document.compatMode == "BackCompat") tmp += 8;
				else tmp += (parseInt(style.borderBottomWidth) || 0);
			}
			if(window.pageYOffset)                      tmp += window.pageYOffset;
			else if(document.documentElement.scrollTop) tmp += document.documentElement.scrollTop;
			else if(document.body.scrollTop)            tmp += document.body.scrollTop;
			if(tmp < resizable.draginfo.min[1]) tmp  = resizable.draginfo.min[1];
			if(resizable.draginfo.max[1] > 0 && tmp > resizable.draginfo.max[1])
			                                    tmp  = resizable.draginfo.max[1];
			resizable.dragobj.style.height = tmp + 'px';
		}

		resizable.preventDefault(event);
//		resizable.stopPropagation(event);
		resizable.resetpos();
		return true;
	},

	// åװ֤Ĵ
	resetpos: function(){
		var target;
		for(var i in resizable.targets){
			target = resizable.targets[i];
			// ֥Ȥΰ֤ȥ
			target.base = resizable.getPosition(target.obj);
			var style = resizable.getStyle(target.obj);

			// åפΰ֤Ĵ
			var tmp;
			var shift = resizable.gripshift;
			// widthheightͤˤʤʤ褦ˤ
			if(target.gripV){
				target.gripV.style.left   = (target.base[0])+'px';
				target.gripV.style.top    = (target.base[1]+target.base[3]+shift)+'px';
				target.gripV.style.width  = (target.base[2]+shift) >= 0 ? (target.base[2]+shift)+'px' : '0px';
				target.gripV.style.height = (resizable.gripsize)+'px';
				target.gripV.style.cliehtHeight = (resizable.gripsize)+'px';
			}
			if(target.gripH){
				target.gripH.style.left   = (target.base[0]+target.base[2]+shift)+'px';
				target.gripH.style.top    = (target.base[1])+'px';
				target.gripH.style.width  = (resizable.gripsize)+'px';
				target.gripH.style.height = (target.base[3]+shift) >= 0 ? (target.base[3]+shift)+'px' : '0px';
			}
			if(target.gripX){
				target.gripX.style.left   = (target.base[0]+target.base[2]+shift)+'px';
				target.gripX.style.top    = (target.base[1]+target.base[3]+shift)+'px';
				target.gripX.style.width  = (resizable.gripsize)+'px';
				target.gripX.style.height = (resizable.gripsize)+'px';
			}
		}
	},


	////////////////////////////////////
	// some useful method
	addEvent : function (obj, name, func) {
		if(obj == undefined || name == '' || func == undefined) return false;

		if(obj.addEventListener) obj.addEventListener(name, func, false);
		else if(obj.attachEvent) obj.attachEvent('on'+name, func);
		else return false;// setAttribute('on'+name, func);

		return true;
	},
	delEvent : function (obj, name, func) {
		if(obj == undefined || name == '' || func == undefined) return false;

		if(obj.removeEventListener) obj.removeEventListener(name, func, false);
		else if(obj.detachEvent)    obj.detachEvent('on'+name, func);
		else return false;// setAttribute('on'+name, '');

		return true;
	},
	preventDefault : function (ev){
		if(isIE)  ev.returnValue = false;
		else      ev.preventDefault();
	},
	stopPropagation : function (ev){
		if(ADIARY.isIE) ev.cancelBubble = true;
		else            ev.stopPropagation();
	}
};

////////////////////////////////////////////////////////////////////////////////
// ꥵк
////////////////////////////////////////////////////////////////////////////////
{
	var resetpos_callfunc = function() {
		resizable.resetpos();
	}
	addEvent(window, 'resize', resetpos_callfunc);

//	addEvent(window, 'resize', resize_func);
}

////////////////////////////////////////////////////////////////////////////////
// 󥿡ե
////////////////////////////////////////////////////////////////////////////////
//function resizable(id, maxheight, maxwidth, minheight, minwidth){
//	return resizableById(id, maxheight, maxwidth, minheight, minwidth);
//}
function resizableById(id, maxheight, maxwidth, minheight, minwidth)
{
	obj = document.getElementById(id);
	if(obj == undefined)
		return false;
	return resizableByObj(obj, maxheight, maxwidth, minheight, minwidth, id);
}

// ꥵϿ
function resizableByObj(obj, maxheight, maxwidth, minheight, minwidth, name)
{
	// ƥ
	if(maxheight == undefined)  maxheight = 0;      // ̵
	if(maxwidth  == undefined)  maxwidth  = 0;      // ̵
	minheight = minheight || resizable.gripsize;
	minwidth  = minwidth  || resizable.gripsize;
	if(obj == undefined || obj == null)return false;
	if(maxheight < 0 && maxwidth < 0)  return false;
	if(minheight < resizable.gripsize) minheight = resizable.gripsize; // gripsizeԥϻĤ
	if(minwidth < resizable.gripsize)  minwidth  = resizable.gripsize;  // gripsizeԥϻĤ

	// ꤵ줿֥Ȥ
	var target = new Object;
	target.obj = obj; //document.getElementById(id);
	if(target.obj == undefined)
		return false;

	// target̾դƤ
	var id;
	target.name = id = (name == undefined || name == null) ? obj.id : name;
	if(target.name == undefined || target.name == null || target.name == '')
		return false;

	// already registerd
	var draginfo = resizable.targets[id];
	if(draginfo != undefined)
		return false;

	// ֥ȤΥ¤¸
	target.max  = [maxwidth, maxheight];
	target.min  = [minwidth, minheight];

	// ֥Ȥ餻褦˥ߡdiv֥å
	var parentobj = document.getElementsByTagName('body');
	parentobj = parentobj[0];
	//	var parentobj = target.obj.parentNode || target.obj;
	if(maxheight >= 0){
		target.gripV = document.createElement('div');
		parentobj.appendChild(target.gripV);
		target.gripV.id = 'gripV_'+id;
		target.gripV.style.position   = 'absolute';
		target.gripV.style.cursor     = 'n-resize';
		target.gripV.setAttribute('title', 'resizable');
		if(isIE){
			target.gripV.style.borderTop  = ''+resizable.gripsize+'px solid red';
			if(!resizable.debug) target.gripV.style.filter     = 'alpha(opacity=0)';
		}else
			if(resizable.debug) target.gripV.style.backgroundColor = 'red';
		resizable.addEvent(target.gripV, 'mousedown', resizable.dragstart);
	}
	if(maxwidth >= 0){
		target.gripH = document.createElement('div');
		parentobj.appendChild(target.gripH);
		target.gripH.id = 'gripH_'+id;
		target.gripH.style.position   = 'absolute';
		target.gripH.style.cursor     = 'w-resize';
		target.gripH.setAttribute('title', 'resizable');
		if(isIE){
			target.gripH.style.borderLeft = ''+resizable.gripsize+'px solid blue';
			if(!resizable.debug) target.gripH.style.filter     = 'alpha(opacity=0)';
		}else
			if(resizable.debug) target.gripH.style.backgroundColor = 'blue';
		resizable.addEvent(target.gripH, 'mousedown', resizable.dragstart);
	}
	if(maxheight >= 0 && maxwidth >= 0){
		target.gripX = document.createElement('div');
		parentobj.appendChild(target.gripX);
		target.gripX.id = 'gripX_'+id;
		target.gripX.style.position   = 'absolute';
		target.gripX.style.cursor     = 'se-resize';
		target.gripX.setAttribute('title', 'resizable');
		if(isIE){
			target.gripX.style.borderTop  = ''+resizable.gripsize+'px solid green';
			if(!resizable.debug) target.gripX.style.filter     = 'alpha(opacity=0)';
		}else
			if(resizable.debug) target.gripX.style.backgroundColor = 'green';
		resizable.addEvent(target.gripX, 'mousedown', resizable.dragstart);
	}

	// ꥹȤɲäơ֥Ȥΰ֤Ĵ
	resizable.targets[target.name] = target;
	resizable.resetpos();

	return true;
}

// ٤ƤΥƥȥꥢɲ
function resizableAllTextarea(maxheight, maxwidth, minheight, minwidth)
{
	// Safari(Google Chrome)ɸбƤΤǲ⤷ʤ
	if (0 < navigator.appVersion.indexOf('Safari'))
		return;

    var T = document.getElementsByTagName('TEXTAREA');
    var i = T.length;
    while(i--){
    	if(T[i].id == undefined || T[i].id == null || T[i].id == '')
    		name = 'TEXTAREA_' + i; // idĤƤʤŬդ
    	else
    		name = T[i].id;
    	resizableByObj(T[i], maxheight, maxwidth, minheight, minwidth, name);
    }
}

// ٤Ƥinput type="text", "password"ɲ
function resizableAllTextbox(maxheight, maxwidth, minheight, minwidth)
{
    var T = document.getElementsByTagName('INPUT');
 	maxheight = maxheight || -1;
    var i = T.length;
    while(i--){
        var elem = T[i];
        if(elem.getAttribute("type") == "text" || elem.getAttribute("type") == "password"){
	    	if(T[i].id == undefined || T[i].id == null || T[i].id == '')
	    		name = 'TEXTBOX_' + i; // idĤƤʤŬդ
	    	else
	    		name = T[i].id;
	    	resizableByObj(T[i], maxheight, maxwidth, minheight, minwidth, name);
        }
    }
}
