#!/usr/bin/perl
use 5.6.0;
use strict;
use lib './lib';
#-------------------------------------------------------------------------------
use FCGI;
use Satsuki::Base ();
use Satsuki::Timer ();
#-------------------------------------------------------------------------------
# Satsuki system - Startup routine (for FastCGI)
#			Copyright (C)2005-2007 nabe@abk / E-mail:nabe@abk.nu
#-------------------------------------------------------------------------------
# Last Update : 2007/01/16

#--------------------------------------------------
# FastCGI ᥤ롼
#--------------------------------------------------
my $request = FCGI::Request();
while($request->Accept() >= 0) {
	#--------------------------------------------------
	# ַ¬
	#--------------------------------------------------
	my $timer = Satsuki::Timer->new();
	$timer->start();
	#--------------------------------------------------
	# ᥤ
	#--------------------------------------------------
	my $ROBJ = Satsuki::Base->new();	# 롼ȥ֥
	$ROBJ->{Timer} = $timer;		# ޡ¸

	#--------------------------------------------------
	# FastCGI ɥå
	#--------------------------------------------------
	$ROBJ->init_for_fastcgi($request, 'Satsuki::');

	#--------------------------------------------------
	# ᥤ
	#--------------------------------------------------
	eval { $ROBJ->start_up(); };
	if ($ROBJ->{FastCGI_LastRequest}) { last; }

	undef %$ROBJ;		# ꡼кɬܡ
}
