#!/usr/local/bin/perl
use strict;
#-------------------------------------------------------------------------------
# Ϥƥѥǡ١ɤ⥸塼
#					(C)2005-07 nabe / ABK project
#-------------------------------------------------------------------------------
# Ϥƥ http://www.hyuki.com/techinfo/hatena_diary_writer.html
#   
#  adiary ǡϤƥΥƥȤȤư
# ѡü˥⥸塼Ǥ̾ӤˤϤޤäѽޤ
#-------------------------------------------------------------------------------
package Satsuki::DB_hatedara;
use Satsuki::DB_pseudo;
our $VERSION = '0.10';

#-------------------------------------------------------------------------------
# ư
#-------------------------------------------------------------------------------
my $parser = "hatena";
my $parser_obj;
###############################################################################
# ܽ
###############################################################################
#------------------------------------------------------------------------------
# ڥ󥹥ȥ饯
#------------------------------------------------------------------------------
sub new {
	my $class = shift;
	my $self  = {};
	bless($self, $class);	# $self 򤳤Υ饹ȴϢդ

	my ($ROBJ, $dir) = @_;
	$self->{ROBJ} = $ROBJ;
	$self->{dir}  = $ROBJ->get_filepath( $dir );
	$ROBJ->mkdir( $self->{dir} . 'cache_diary/' );

	# å
	$self->check_new_hatedara_text();

	# DB_pseudo Ф $self  $ROBJ Ȼפ碌
	my $DB = Satsuki::DB_pseudo->new( $self, $dir );
	$self->{DB} = $DB;

	# ǥե
	$DB->{_RDBMS} = 'ϤƤtext';
	$DB->{db_id}  = "$dir:hatedara:";
	return $DB;
}

#------------------------------------------------------------------------------
# ڥǥȥ饯
#------------------------------------------------------------------------------
sub DESTROY {
}

###############################################################################
# ǥ쥯ȥեιå
###############################################################################
#------------------------------------------------------------------------------
# å
#------------------------------------------------------------------------------
sub check_new_hatedara_text {
	my $self = shift;
	my $dir  = $self->{dir};
	my $ROBJ = $self->{ROBJ};
	my $DB   = $self->{DB};

	my $cache_dir = $dir . 'cache_diary/';
	my $db_index  = $cache_dir . '#index.dat';
	my $index_tm  = $ROBJ->get_file_lastmodified( $db_index );
	if (! $index_tm) { return 1; }

	my @new;
	my $files = $ROBJ->search_files( $dir );
	foreach(@$files) {
		if ($_ =~ /(\d\d\d\d)\-(\d\d)\-(\d\d)\.txt$/) {
			my $tm = $ROBJ->get_file_lastmodified( "$dir$_" );
			if ($tm < $index_tm) { next; }
			push(@new, "$1$2$3");
		}
	}
	if (! @new) { return 2; }
	#---------------------------------------------
	# ǡ
	#---------------------------------------------
	unlink( $db_index );
	#foreach(@new) {
	#	$file = $cache_dir . "$_.dat";
	#	my $update_flag;
	#	if (-e $file) { $update_flag=1; }	# Ǥ˥ǡ
	#	my $h = $self->fread_hash( $file );
	#	if ($update_flag) {
	#		$DB->update_match('cache_diary', $h, 'pkey', $_);
	#	} else {
	#		$DB->insert_with_pkey('cache_diary', $h);
	#	}
	#}
	return 0;
}

###############################################################################
# 롼ȥ֥Ȥε
###############################################################################
#------------------------------------------------------------------------------
# AutoLoader
#------------------------------------------------------------------------------
our ($AUTOLOAD);
sub AUTOLOAD {
	if ($AUTOLOAD eq '') { return; }
	my $x    = rindex($AUTOLOAD, '::');
	my $func = substr($AUTOLOAD, $x+2);
	# ROBJ ƤӽФ
	my $self = shift;
	my $ROBJ = $self->{ROBJ};
	return $ROBJ->$func(@_);
}

#------------------------------------------------------------------------------
# ϥåˤߤƤϤƤΥƥɤ߹
#------------------------------------------------------------------------------
sub fread_hash_cached {
	return &fread_hash(@_);
}

sub fread_hash {
	my $self = shift;
	my $file = shift;
	my $ROBJ = $self->{ROBJ};

	# å塩
	my $cache = $file;
	$file  =~ s|cache_diary/(\d\d\d\d)(\d\d)(\d\d)\.dat|$1-$2-$3.txt|;
	my $yyyymmdd = "$1$2$3";
	my $file_tm  = $ROBJ->get_file_lastmodified( $file  );
	my $cache_tm = $ROBJ->get_file_lastmodified( $cache );
	if ($file_tm < $cache_tm) {
		return $ROBJ->fread_hash_cached( $cache );
	}

	# file̾ù
	#   yyyymmdd to yyyy-mm-dd
	my $lines = $ROBJ->fread_lines_cached( $file );
	my %h;
	$h{pkey}     = $yyyymmdd;
	$h{yyyymmdd} = $yyyymmdd;
	$h{title}    = shift(@$lines);		# ǽΣԤϥȥ
	$h{parser}   = 'hatena';
	if ($h{title} ne 'delete') { $h{enable} = 1; }
	$h{tm}       = $file_tm;
	$h{update}   = $h{tm};

	# ƥȽ
	my $text = join('', @$lines);
	if ($text =~ /^\*[t\d\+\*]*\[(.*?)]/ || $text =~ /\n*[t\d\+\*]*\[(.*?)]/) {
		$h{category}      = $1;
		$h{category_main} = $1;
	}
	$h{_text}  = $text;
	if (!defined $parser_obj) {
		$ROBJ->call(  $ROBJ->{v}->{parser_skelton_dir} . $parser );
		$parser_obj = $ROBJ->{v}->{parser};
	}
	if ($parser_obj->{use_preprocessor}) {	# ץץå
		$parser_obj->preprocessor( \$text );
	}
	$parser_obj->{thispkey} = $yyyymmdd;
	$parser_obj->{thisurl}  = $self->{myself2} . "0$yyyymmdd";
	$parser_obj->{thisyear} = substr($yyyymmdd, 0, 4);
	$parser_obj->{thismon}  = substr($yyyymmdd, 4, 2);
	$parser_obj->{thisday}  = substr($yyyymmdd, 6, 2);
	$h{text} = $parser_obj->text_parser( $text );

	# Υ
	$ROBJ->tag_escape( $h{title}, $h{category}, $h{category_main} );

	# å¸
	$ROBJ->fwrite_hash( $cache, \%h );
	return \%h;
}


#------------------------------------------------------------------------------
# եꥹȼ
#------------------------------------------------------------------------------
sub search_files {
	my $self = shift;
	my $dir  = shift;
	my $ROBJ = $self->{ROBJ};

	$dir =~ s|cache_diary/||;
	my $files = $ROBJ->search_files( $dir );
	foreach(@$files) {
		# ϤƤե pkey ե˸
		$_ =~ s/(\d\d\d\d)\-(\d\d)\-(\d\d)\.txt/$1$2$3.dat/;
	}
	return $files
}

#------------------------------------------------------------------------------
# 񤭴ϤǤʤ
#------------------------------------------------------------------------------
sub fwrite_hash {
	return ;
}


1;	# ޤʤ
