#!/usr/local/bin/perl
require 5.004;
use strict;
#-------------------------------------------------------------------------------
# ƥ
#					(C)2006-2008 nabe@abk / ABK project
#-------------------------------------------------------------------------------
package Satsuki::Diary;
use Satsuki::AutoLoader;
#-------------------------------------------------------------------------------
our $VERSION = '2.11';
our $SUBVERSION = '';
###############################################################################
# ܽ
###############################################################################
#------------------------------------------------------------------------------
# ڥ󥹥ȥ饯
#------------------------------------------------------------------------------
sub new {
	my ($class, $ROBJ, $self) = @_;
	if (ref($self) ne 'HASH') { $self={}; }
	bless($self, $class);	# $self 򤳤Υ饹ȴϢդ

	$self->{ROBJ}    = $ROBJ;	# root object save
	$self->{options} = {};		# HASH ref
	$self->{tb}      = {};		# HASH ref
	$self->{VERSION} = $VERSION;
	$self->{SUBVERSION} = $SUBVERSION;

	$self->{frame_skelton} = '_frame';

	# ߤѹк
	$self->{tm}  = $ROBJ->{TM};
	$self->{now} = $ROBJ->{Now};
	# Trackback  USER AGENT
	$self->{http_agent} = "adiary $VERSION on Satsuki-system $ROBJ->{VERSION}";

	# CacheĶ Timer Υ
	if ($ROBJ->{CGI_cache} && !$Satsuki::Timer::VERSION) {
		require Satsuki::Timer;
	}
	return $self;
}

#------------------------------------------------------------------------------
# ڥǥȥ饯
#------------------------------------------------------------------------------
sub DESTROY {
}

###############################################################################
# ᥤ
###############################################################################
sub main {
	my $self  = shift;
	my $ROBJ  = $self->{ROBJ};
	my $query = $ENV{QUERY_STRING};
	$query =~ s/&.*//;	# & ʹߤ̵

	# VersionȤκʬѥå
	$self->{trust_mode} ||= $self->{reliable_mode};

	# ѿ¸
	$self->{theme_bak}        = $self->{theme};
	$self->{template_dir_bak} = $self->{template_dir};

	$ROBJ->get_cookie();		# cookieɤ߹
	my $cookie      = $ROBJ->{Cookie};
	my $skelton_dir = $ROBJ->{Skelton_dir};

	# Cookie 
	if ($ROBJ->{Cookie_path} eq '') { $ROBJ->{Cookie_path} = $ROBJ->{Basepath}; }
	# secure id Ĺʥǥե͡
	$ROBJ->{Secure_id_len} ||= 3;

	#-------------------------------------------------------------
	# ƥॳեɤ߹
	#-------------------------------------------------------------
	#my $cfg = $ROBJ->fread_hash( $self->{system_config_file} );
	#$self->{cfg} = $cfg;
	# $ROBJ->debug($cfg->{version});

	#-------------------------------------------------------------
	# Cookie  Authorization 
	#-------------------------------------------------------------
	my $auth = $ROBJ->{Auth};
	my $session = $cookie->{session};
	if (ref $session eq 'HASH') {	# 󥻥å
		$auth->session_auth($session->{id}, $session->{sid});
		$ROBJ->make_csrf_check_key($session->{sid});
	}
	# if ($cookie->{time}) { $ROBJ->update_modtime($cookie->{time}); }	# not use

	#-------------------------------------------------------------
	# ȥ PATH (URL) ù
	#-------------------------------------------------------------
	# PATHINFO βù
	$self->{server_url} = $ROBJ->{Server_url};	# ֥ɥᥤбؤ
	$self->{path_info}  = substr($ENV{PATH_INFO}, 1);
	$self->{query}      = $query;
	$self->{query}      =~ s/%([0-9a-fA-F][0-9a-fA-F])/chr(hex($1))/eg;
	$ROBJ->form_encode( $self->{path_info}, $self->{query} );
	my $myself  = $ROBJ->{Myself};
	my $myself2 = $ROBJ->{Myself2};
	my $pinfo   = $ROBJ->read_path_info();	# PATH_INFOɤ߹
	# ӥڡȽ
	my $myselfp;
	my $p0 = $pinfo->[0];
	if ($p0 eq 'm') {
		shift(@$pinfo);
		$self->{path_info}   = substr($ENV{PATH_INFO}, 3);
		$self->{phone_mode}  = 1;
		$self->{phone_query} = 'm/';
	} elsif ($p0 =~ /^=(\w+):(.*)/) {	# 󤿤
		shift(@$pinfo);
		$self->{path_info} = join('/', @$pinfo);
		$self->{phone_mode} = 2;
		my $userid    = $1;
		my $secure_id = $2;
		my $u = $auth->get_userinfo($userid);
		my $phone_id = $ROBJ->get_phone_id();
		# ϿƤγǧֹȾȹ
		if ($phone_id ne '' && $u->{info} eq $phone_id) {
			# secure id ǧ
			# ա$self->phone_id_regist Ȥ뤳
			my $secu2 = $ROBJ->make_secure_id($phone_id, -1, 12);
			if ($secure_id eq $secu2) {
				if ($auth->{ok}) { $auth->logout(); }
				$auth->force_auth($u->{id});
				$self->{phone_query} = "$p0/";
				$ROBJ->make_csrf_check_key($phone_id);
			}
		}
	} elsif ($p0 =~ /^=(\w+)=(.*)/) {	# ӥåǧ
		shift(@$pinfo);
		$self->{path_info} = join('/', @$pinfo);
		$self->{phone_mode} = 3;
		my $id  = $1;
		my $sid = $2;
		if ($auth->session_auth($id, $sid)) {
			$self->{phone_query} = "$p0/";
			$ROBJ->make_csrf_check_key($sid);
		}
	}
	if ($ROBJ->{Is_phone} && $self->{phone_mode}<2) {
		$self->{phone_mode}  = 1;
		$self->{phone_query} = '';
	} 
	if ($self->{phone_mode}) {
		$myselfp = $myself2 . $self->{phone_query};
		$ROBJ->{Myselfp} = $ROBJ->{Myself2p} = $myselfp;
		$self->{theme}        = $self->{phone_theme};	
		$self->{template_dir} = $self->{phone_template_dir};
	}

	# URLʤɴ
	my $DB = $ROBJ->{DB};
	my $diary_id;
	my $set = {};
	my $auth_id = $auth->{id};
	my $pinfo_id = $pinfo->[0];	# 裱
	my $daybook_setting_loaded;
	if ($self->{single_mode} ne '' && $pinfo_id =~ /^[a-z][a-z0-9_]*$/) {
		# 󥰥桼⡼ɤγĥ
		if ($DB->find_table("${pinfo_id}_diary")) {
			$set = $self->set_and_select_daybook( $pinfo_id );
			if ($self->{allow_edit} || $set->{enable_force} ne '0') {
				$daybook_setting_loaded = 1;
			}
		}
	}
	if ($self->{single_mode} ne '' && ! $daybook_setting_loaded) {
		$self->{diary_id} = $diary_id = $self->{single_mode};
		$self->{myself}   = $myself;		# ̾ѡQUERY
		$self->{myself2}  = $myself2;		# PATH_INFO
		$self->{myself3}  = $myself;		# ʬĢ
		if ($self->{phone_mode}) {
			$self->{myselfp} = $self->{myself2p} = $self->{myself3p} = $myselfp;
		}
	} elsif ($self->{subdomain_mode}) {
		# ֥ɥᥤ⡼
		my $host_name = $ENV{SERVER_NAME};
		$host_name =~ s/[^\w\.\-]//g;
		my $domain = $self->{subdomain_mode};
		if (! $self->{subdomain_secure}) {		# ɥᥤ cookie
			$ROBJ->{Cookie_domain} = $domain;	# "." w3m security violation к
		}
		if ((my $x = index($host_name, ".$domain")) > 0) {
			$self->{diary_id} = $diary_id = substr($host_name, 0, $x);
		} else {
			$diary_id = shift(@$pinfo);
			$diary_id =~ s/\W//g;
			if ($diary_id ne '') {
				$ROBJ->redirect("http://$diary_id.$domain/" . join('/', @$pinfo));
			}
		}
		$self->{myself}     = '/';	# ̾ѡQUERY
		$self->{myself2}    = '/';	# PATH_INFO
		$self->{myself3}    = "http://$auth_id.$domain/";	# ʬĢ
		if ($self->{phone_mode}) {
			$self->{myselfp}  = $self->{myself2p} = $self->{myself} . $self->{phone_query};
			$self->{myself3p} = $self->{myself3} . $self->{phone_query};
		}
	} else {
		# ޥ桼⡼
		$diary_id = shift(@$pinfo);
		$diary_id =~ s/\W//g;
		$self->{diary_id} = $diary_id;
		if ($diary_id ne '') { $self->{myself} = $myself2 . "$diary_id/"; }	# ̾ѡQUERY
				else { $self->{myself} = $myself2; }			# ̾ѡQUERY
		my $add_myself3;
		if ($self->{single_mode} ne $auth_id) { $add_myself3 = "$auth_id/"; }
		$self->{myself2} = $self->{myself};		# PATH_INFO 
		$self->{myself3} = $myself2 . $add_myself3;	# ʬĢ
		if ($self->{phone_mode}) {
			$self->{myselfp}  = $self->{myself2p} = $myselfp . "$diary_id/";
			$self->{myself3p} = $myselfp . $add_myself3;
		}
	}
	#-------------------------------------------------------------
	# ¾
	#-------------------------------------------------------------
	if ($self->{root_trust_mode} && $auth->{admin}) {
		$self->{trust_mode} = 1;		# ԤΤ trust_mode
	}

	#-------------------------------------------------------------
	# γǧ
	#-------------------------------------------------------------
	if ($auth->{ok} && $DB->find_table("${auth_id}_diary") ) {
		$self->{exsits_my_daybook} = 1;
	}
	if ($diary_id ne '') {	# Ģλꤢ
		if (($daybook_setting_loaded
		  || $diary_id eq $auth_id && $self->{exsits_my_daybook})
		  || $diary_id ne $auth_id && $DB->find_table("${diary_id}_diary") ) {
			if (! $daybook_setting_loaded) {
				$set = $self->set_and_select_daybook( $diary_id );
			}
			$self->{exsits_daybook}   = 1;
			$self->{this_archive_dir} = "$ROBJ->{Basepath}$self->{archive_dir}$diary_id/";
		}
		if ($diary_id ne $auth_id) {
			$self->{others_daybook} = 1;
		}
	}
	if (! $self->{exsits_daybook}) {
		$set = $self->set_and_select_daybook();		# Set skelton dir
	}
	# 
	if (! $self->{allow_edit} && $set->{enable_force} eq '0') {
		$self->{exsits_daybook} = 0;
		$set = $self->{daybook_setting} = undef;
		$self->{theme}        = $self->{theme_bak};
		$self->{template_dir} = $self->{template_dir_bak};
	}

	#-------------------------------------------------------------
	# եȥåХå
	#-------------------------------------------------------------
	# եɤ߹
	if ($self->{phone_mode} && $self->{phone_sjis} && $ENV{QUERY_STRING} =~ /&code=sjis/) {
		$ROBJ->{UA_code} = "Shift-JIS";	# form/query ǡ sjis
	}
	$ROBJ->read_form();

	# queryʬ
	my @query;
	$self->{query_ary} = \@query;
	if (index($query,'=') < 0) {	# = ޤޤʤ
		$query =~ s/[^\w\/\-\+]//g;
		@query = split('/', $query);
	}
	# display op("tb"˻äƤäƤϥ)
	my $display_op = $pinfo->[0];
	if ($display_op eq '' && $set->{frontpage} ne '') {	# FrontPageǽ(wiki)
		@$pinfo = (); $display_op = $set->{frontpage};
	}
	$self->{display_op} = $display_op;

	if ($pinfo->[1] eq 'tb') { return $ROBJ->call_action( 'trackback' ); }
	if ($ROBJ->{POST}) {
		$self->{action_data} = $ROBJ->call_action( $ROBJ->{Form}->{action} );
	}

	#-------------------------------------------------------------
	# ɽȥ
	#-------------------------------------------------------------
	my $skelton = $query[0];
	# Ƭ _ Υȥ Τ ΥȥĤʤ
	if (substr($skelton,0,1) eq '_' || $skelton =~ /^\d*$/) {
		if ($display_op =~ /^0(\d+)$/	# pkey
		 || $display_op >99999999	# tm(UTC)
		 || $display_op =~ /^[^&\d]/	# wiki
		 || $display_op =~ /^\d{8}$/	# ջ
		) {
			$skelton = '_main_onelog';
			$self->{onelog_mode} = 1;
		} elsif ($self->{single_mode} eq '' && $diary_id eq '') {	# ޥ桼⡼
			$skelton = $self->{multiuser_top_skelton};
			if ($self->{phone_mode}) { $skelton = $self->{phone_multiuser_top_skelton}; }
		} else {
			$skelton = '_main';
		}
	}
	if ($skelton ne '') {
		my $file = $ROBJ->check_skelton($skelton);
		if (! defined $file) {
			$ROBJ->redirect( $ROBJ->{Myself} );
		}
	}
	#-------------------------------------------------------------
	# pop ޡ
	#-------------------------------------------------------------
	if ($self->{pop_timer}) {
		my $tm = $ROBJ->get_file_lastmodified( $self->{pop_log_file} );
		if ($tm + $self->{pop_timer} < $ROBJ->{TM}) {
			$self->{no_cache} = 1;
			$self->{pop_check_flag} = 1;
		}
	}
	$self->output_html($skelton);
}

###############################################################################
# ɽ
###############################################################################
#------------------------------------------------------------------------------
# HTMLȽ
#------------------------------------------------------------------------------
sub output_html {
	my $self = shift;
	my $ROBJ = $self->{ROBJ};
	my ($skelton) = @_;

	# HTML
	my $out;
	if ($self->{action_is_main}) {
		$out = $self->{action_data}
	} else {
		$out = $ROBJ->call($skelton);
	}

	# mainե졼ढꡩ
	my $frame_name = $self->{frame_skelton};
	if ($frame_name ne '') {
		$self->{inframe} = $out;
		# ե졼
		$out = $ROBJ->call($frame_name);
	}

	#  Last-Modified Ϥʤ褦ѹ
	# Last-modified 
	#	my $cookie_tm = $ROBJ->{Cookie}->{"time"};
	#	if ($cookie_tm && $ROBJ->{Lastmodified} > $cookie_tm) {
	#		$ROBJ->clear_cookie("time");	# פˤʤä cookie õ
	#	}
	if ($ROBJ->{POST} || $ROBJ->{Auth}->{ok} || $self->{no_cache}) {	# POST/loginϤ
		$ROBJ->print_header( "Cache-Control", 'no-cache' );
	} else {
		$ROBJ->print_lastmodified( $self->{force_last_modified} );
	}
	my $code = $ROBJ->{System_coding};
	if ($self->{phone_mode}) {
		my $str  = $ROBJ->chain_array($out);
		if ($self->{phone_sjis}) {
			my $jcode = $ROBJ->loadpm("Jcode");
			$jcode->from_to(\$str, $code, 'Shift_JIS');
			$code = "Shift_JIS";
		}
		$ROBJ->print_header( "Content-Length", length($str) );
		$out = \$str;
	}
	$ROBJ->print_content_type($self->{content_type} || "text/html", $code);
	$ROBJ->output_array($out);	# HTML

	# ³⡼
	if ($self->{continual_file}) {
		$self->{continue}=1;
		$ROBJ->call( 'action/'.$self->{continual_file} );
		$ROBJ->print("</body></html>\n");
	}
}

###############################################################################
# ȥѥ֥롼
###############################################################################
#------------------------------------------------------------------------------
# ƥ⡼ɤ
#------------------------------------------------------------------------------
sub system_mode {
	my ($self, $force) = @_;
	my $ROBJ = $self->{ROBJ};
	$self->{system_mode} = 1;

	if (!$force) {
		my $file = $ROBJ->get_filepath($self->{template_dir}) . $self->{theme} . '/system_mode_yes';
		if (-e $file) { return ; }		# ƥ⡼бơ  ⤷ʤ
	}
	$self->{theme}        = $self->{system_theme};
	$self->{template_dir} = $self->{system_template_dir};
	# user templateoff
	$ROBJ->{User_skelton_dir2} = undef;	# userȥ
	$ROBJ->{User_skelton_dir3} = undef;	# ơ
}

#------------------------------------------------------------------------------
# Υ
#------------------------------------------------------------------------------
# 	diary.cgi/user_id/20060111
# 	diary.cgi/20060111
#
sub load_diary {
	my ($self, $diaries, $set, $display_op_arg, $special) = @_;
	my $ROBJ = $self->{ROBJ};
	my $DB   = $ROBJ->{DB};
	my $diary_id  = $self->{diary_id};

	my $phone_mode;
	if ($display_op_arg eq '*phone') { $phone_mode=1; $display_op_arg=undef; }
	my $display_op = $display_op_arg || $self->{display_op};

	# Ģ¸ߤʤ
	if (!$self->{exsits_daybook}) { return []; }

	# ȥ
	my ($dummy, @pinfo) = @{ ($ROBJ->{Pinfo} || []) };	# dummy = display 
	my $day_sort_order = $set->{disp_daysort};
	my $tm_sort_order  = $set->{disp_tmsort};
	my $tm_sort_order2 = $set->{disp_tmsort2};
	my $sort_select;
	my $default_sort_order = 1;	# ߽
	if ($dummy eq $display_op) {
		if ($pinfo[$#pinfo] eq ' ') {	#  +
			pop(@pinfo);
			$default_sort_order = $day_sort_order = $tm_sort_order = $tm_sort_order2 = 0;	# 
			$sort_select = '/+';
		} elsif ($pinfo[$#pinfo] eq '-') {
			pop(@pinfo);
			$day_sort_order = $tm_sort_order = $tm_sort_order2 = 1;	# ߽
			$sort_select = '/-';
		}
	}

	my %h;
	my $cache_on;
	my $page_mode;
	my $query = $ROBJ->read_query();
	my @words;		# 
	my $exclusive_wiki;	# ƥĽԤ⡼
	if ($display_op =~ /^0(\d+)$/) {		# pkey
		$h{match_int} = {pkey => $1};
		$self->{diary_pkey_selected} = 1;	# ⡼
		$h{limit} = 1;
		$cache_on = 1;

	} elsif ($display_op >99999999) {		# ʻ
		$h{match_int} = {tm => int($display_op)};
		$h{limit} = 1;
		$cache_on = 1;

	} elsif ($display_op =~ /^(\d\d\d\d)(\d\d)$/) {	# YYYYMM
		my $err = $self->check_date($1, $2);
		if ($err ne '') { $ROBJ->message($err); return []; }
		else {
			$self->{month_mode} = 1;
			$self->{calendar_year} = $1;
			$self->{calendar_mon}  = $2;
			$h{min} = {yyyymmdd => "$1${2}01"};
			$h{max} = {yyyymmdd => "$1${2}31"};
			$h{sort}          = 'yyyymmdd';
			$h{sort_reverse}  = $day_sort_order;	# ե
			$h{sort2}         = 'tm';
			$h{sort2_reverse} = $tm_sort_order;	# ⥽
			$page_mode        = 1;
			$h{limit}         = int($diaries);
			$ROBJ->message("Diary of %d/%d", $1, $2);
		}
	} elsif ($display_op =~ /^(\d\d\d\d)(\d\d)(\d\d)$/) {	# YYYYMMDD
		my $err = $self->check_date($1, $2, $3);
		if ($err ne '') { $ROBJ->message($err); return []; }
		else {
			$self->{calendar_year} = $1;
			$self->{calendar_mon}  = $2;
			$self->{calendar_day}  = $3;
			$h{match_int}    = {yyyymmdd => "$1$2$3"};	# ջ
			$h{sort}         = 'tm';
			$h{sort_reverse} = $tm_sort_order2;		# ⥽
			$self->{day_selected} = 1;			# ⡼
			$cache_on = 1;
			delete $h{limit};				# Ʊ⤹٤ɽ
		}

	} elsif ($display_op =~ /^[^0-9&-]/) {	# wikiŪ
		my $link_key = join('/', $display_op, @pinfo);
		$self->{diary_pkey_selected} = 1;		# ⡼
		$self->{diary_wiki_selected} = 1;		# wiki⡼
		$h{match_str} = {link_key => $link_key};

	} elsif ($display_op eq '&id' && $query->{id} ne '' ) {	# id
		my $id = $query->{id};
		$id =~ s/\W//g;
		$self->{id_serach_mode} = $id;
		# ǡ
		$h{match_str} = {id => $id};
		$h{sort}          = 'yyyymmdd';
		$h{sort_reverse}  = $day_sort_order;		# ե
		$h{sort2}         = 'tm';
		$h{sort2_reverse} = $tm_sort_order;		# ⥽
		$page_mode        = 1;
		$h{limit}         = int($diaries);
		$ROBJ->message("Search for ID '%s'", $id);

	} elsif ($display_op eq '&category' && $query->{cat} ne '' ) {
		my $category = $query->{cat};
		$self->{category_mode} = $category;	# ƥ⡼
		# ǡ
		if (index($category, '::') >=0) {
			if (substr($category,-2) eq '::') { chop($category); chop($category); }
			$h{match_str} = {category => $category};		# ƥ긡
		} else {
			$h{match_str} = {category_main => $category};		# ƥ긡
		}
		$h{sort}          = 'yyyymmdd';
		$h{sort_reverse}  = $day_sort_order;		# ե
		$h{sort2}         = 'tm';
		$h{sort2_reverse} = $tm_sort_order;		# ⥽
		$page_mode        = 1;
		$h{limit}         = int($diaries);
		$ROBJ->message("Search for category '%s'", $category);

	} elsif ($display_op eq '&search' && $query->{word} ne '') {	# ʸ
		my $word  = $query->{word};
		$word =~ s/(?:\G|\s+)(?:([^\"\'\s]+)|"(.*?)"|'(.*?)')/push(@words, "$1$2$3")/eg;
		@words = grep { ! m/^[\s\n\r]*$/ } @words;
		$h{search_words}  = \@words;
		if ($query->{all} == 2) {
			$h{search_cols}  = ['text'];
			$ROBJ->message("Search for '%s'", $query->{word});
		} elsif ($query->{all}) {
			$h{search_cols}  = ['title', 'text'];
			$ROBJ->message("Search for '%s'", $query->{word});
		} else {
			$h{search_cols}  = ['title'];
			$ROBJ->message("Search title for '%s'", $query->{word});
		}
		$h{sort}          = 'yyyymmdd';
		$h{sort_reverse}  = $day_sort_order;		# ե
		$h{sort2}         = 'tm';
		$h{sort2_reverse} = $tm_sort_order;		# ⥽
		$page_mode        = 1;
		$h{limit}         = int($diaries);

	} elsif ( ref($special) eq 'HASH' ) {
		# ü롼󤫤Ȥ - 裲RSSʤ
		foreach(keys(%$special)) {
			$h{$_} = $special->{$_};		# 拾ԡ
		}
		$h{sort}          ||= 'yyyymmdd';
		$h{sort_reverse}  ||= $day_sort_order;		# ե
		$h{sort2}         ||= 'tm';
		$h{sort2_reverse} ||= $tm_sort_order;		# ⥽
		$h{limit}         = int($diaries);
		$exclusive_wiki   = 1;

	} else {	# $display_op eq '&n' / Ƕ n 
		# Ȼѹ generate_kyelist() ѹΤ
		$display_op       = '';
		$h{sort}          = 'yyyymmdd';
		$h{sort_reverse}  = 1; #$set->{disp_daysort};	# եȡʿ
		$h{sort2}         = 'tm';
		$h{sort2_reverse} = $tm_sort_order;		# ⥽
		$cache_on         = 1;
		$page_mode        = 1;
		$h{limit}         = int($diaries);
		$exclusive_wiki   = 1;
	}
	# wikiƥĤɽ
	if ($exclusive_wiki && $set->{contents_separate}) {	# ƥĤ
		$h{match_int} = {priority => 0};
	}
	# ڡ
	my $limit = $h{limit};
	my $page;
	$self->{prev_page} = $self->{next_page} = undef;
	if ($page_mode) {
		$page = int(substr(shift(@pinfo), 1));
		if ($page < 0) { $page=0; }
		$h{offset} = $page * $limit;
		$h{limit} += 1;		# ڡ
	}
	# å
	if (! $self->{allow_edit}) {	# Խ¤ʤ 0 ڡ
		$h{flag} = {enable => 1};	# ɽǽΤ
		if (! $page) {
			$h{cache} = $cache_on;	# [DB_cache] å on
		}
	}
	# $h{require_hits} = 1;
	my $logs = $DB->select("${diary_id}_diary", \%h);

	# ڡڡ
	my $myself2 = $phone_mode ? $self->{myself2p} : $self->{myself2};
	if ( exists $set->{keylist} && $self->{onelog_mode} && $logs->[0]) {	#  or ջ
		if ($page_mode && $#$logs == $limit) { pop(@$logs); }
		my $key = $logs->[0]->{link_key} || $logs->[0]->{pkey};
		my $keylist = $set->{keylist};
		if ($self->{allow_edit}) { $keylist = $set->{keylist_all}; }
		# key õ
		$key =~ s/([^0-9A-Za-z\x80-\xff])/"\\x" . unpack('H2',$1)/eg;
		if ($key && $keylist =~ /([^,]*),$key,([^,]*)/) {
			if ($1 ne '') {
				$ROBJ->form_encode(my $x = $1);
				$self->{next_page} = $myself2 . $x;
			}
			if ($2 ne '') {
				$ROBJ->form_encode(my $x = $2);
				$self->{prev_page} = $myself2 . $x;
			}
		}
	} elsif ($page_mode) {
		$display_op =~ s/[^A-Za-z0-9&]//g;
		my $query_str;
		if ($display_op eq '&category' || $display_op eq '&search' || $display_op eq '&id') {
			$query_str = $ENV{QUERY_STRING};
			$query_str =~ s/([^\.\/\~\*\-\w=\+\&\?:;%])/'%' . unpack('H2',$1)/eg;
			$query_str = '?' . $query_str;
		}
		if ($page == 1) {
			$self->{prev_page} = "$myself2$display_op";
		}
		if ($display_op eq '') { $display_op = '&amp;'; }
		if ($page > 1) {
			my $p = $page - 1;
			$self->{prev_page} = "$myself2$display_op/p$p$sort_select";
		}
		if ($page > 0 && $query_str) { $self->{prev_page} .= $query_str; }
		# Υڡ
		if ($#$logs == $limit) {	# ;פ˼郎¸ߤ
			pop(@$logs);		# ɤ߼Τ
			my $p = $page + 1;
			$self->{next_page} = "$myself2$display_op/p$p$sort_select";
			if ($query_str) { $self->{next_page} .= $query_str; }
		}
	}

	# ե饰ΥС饤ɳǧ
	if (ref $set eq 'HASH') {
		foreach my $flag (qw(lf2br indent allow_com allow_hcom allow_tb disp_ref)) {
			if ($set->{"${flag}_force"} ne '') {
				my $ow = $set->{"${flag}_force"};
				foreach(@$logs) {
					$_->{$flag} = $ow;
				}
			}
		}
	}

	# ξ硢ɽѴ
	@words = map {
		$_ =~ s/([^0-9A-Za-z\x80-\xff])/"\\x" . unpack('H2',$1)/eg;
		$_ = qr/((?:$_)+)/i;
	} @words;
	my $search_base = "${myself2}&amp;category?cat=";
	if ($phone_mode) {
		$myself2 = $self->{myself2p};
		$search_base = "$myself2?diary_list/&amp;cat=";
	}
	#-----------------------------------------------
	# ǡ
	#-----------------------------------------------
	my %options;
	$options{see_all} = $self->{day_selected} || $self->{diary_pkey_selected} || $self->{phone_mode};
	if ($display_op_arg eq '&rss') { $options{see_all}=0; }
	$options{category_search_base} = $search_base;
	$options{myself2} = $myself2;
	$options{words}   = \@words;
	$options{search_all}  = $query->{all};
	$options{static_mode} = $self->{static_mode};	# Ū󥯥⡼

	foreach(@$logs) {
		$self->process_daylog( $_, \%options );

		#--------------------------
		# ­ʤ
		#--------------------------
		# ս
		if ($self->{diary_pkey_selected}) {
			$self->{calendar_year} = $_->{year};
			$self->{calendar_mon}  = $_->{mon};
			$self->{calendar_day}  = $_->{day};
		}
	}

	$self->{load_days} = $#$logs +1;
	return $logs;	# ɤ
}


#------------------------------------------------------------------------------
# ǡβù
#------------------------------------------------------------------------------
sub process_daylog {
	my $self = shift;
	my ($dat, $options) = @_;
	my $ROBJ = $self->{ROBJ};

	my $yyyymmdd = $dat->{yyyymmdd};
	my $year = $dat->{year} = substr($yyyymmdd, 0, 4);
	my $mon  = $dat->{mon}  = substr($yyyymmdd, 4, 2);
	my $day  = $dat->{day}  = substr($yyyymmdd, 6, 2);
	if ($dat->{title} eq "$year-$mon-$day") { $dat->{title}=''; }

	# μ
	$dat->{wday} = $self->get_dayweek($dat->{year}, $dat->{mon}, $dat->{day});
	$dat->{wday_name}  = $ROBJ->{WDAY_name}->[ $dat->{wday} ];

	my $pkey = $dat->{pkey};
	my $key  = $dat->{link_key};
	if ($key ne "0$pkey") { $dat->{wiki}=1; }
	$ROBJ->form_encode($key, $dat->{eupnode} = $dat->{upnode});
	my $diary_id = $options->{diary_id} || $self->{diary_id};

	# URLϤ
	$dat->{elink_key}      = $key;
	if ($key eq 'FrontPage') {
		$dat->{this_diary_url} = $options->{myself2};
	} else {
		$dat->{this_diary_url} = $options->{myself2} . $key;
	}
	$dat->{this_day_url}   = $options->{myself2} . $yyyymmdd;
	$dat->{secure_id_seed} = $diary_id . $dat->{pkey};		# secure id μ
	$dat->{this_diary_pkeyurl} = $options->{myself2} . '0' . $dat->{pkey};
	$dat->{tb_url_base}    = $self->{server_url} . $dat->{this_diary_pkeyurl} . '/tb/';

	my $category      = $dat->{category};
	my $category_main = $dat->{category_main};
	if ($category eq $category_main) { $category .= '::'; }
	$dat->{category_sub} = substr($category, length($category_main)+2 );
	$ROBJ->form_encode( $category, $category_main );
	$dat->{category_uri}      = $options->{category_search_base} . $category;
	$dat->{category_main_uri} = $options->{category_search_base} . $category_main;

	#³ɤפνλͤѹϼ˺줺ѹΤȡ
	#	 ȥåХåRSSݡ
	if ($options->{see_all}) {
		$dat->{text} =~ s/<!--%msg-->.*?<!--%msg-->|<!--%more-->//sg;
	} else {
		$dat->{text} =~ s/<!--%msg-->|<!--%more-->.*?<!--%more-->//sg;
	}
	# ξ
	if (ref $options->{words}) {
		my @words = @{ $options->{words} };
		if (@words && $options->{search_all}==2) {	# section
			my @tags;
			my @sections = split(m[(?:\G|\n)<div\s*class="section">\n], $dat->{text});
			foreach my $q (@words) {
				@sections = grep { /$q/ } @sections;
			}
			$dat->{text} = join("<div class=\"section\">\n", '', @sections);
		} elsif (@words) {
			my @save;
			$dat->{text} =~ s/(<\/.*?>|&#\w+;|<(?:[^>"']|[=\s]".*?"|[=\s]'.*?')*?>)/push(@save, $1), "\x01$#save\x01"/seg;
			if ($self->{phone_mode}) {
				foreach my $q (@words) {
					$dat->{title} =~ s|$q|push(@save, "<font color=\"red\">$1</font>"), "\x01$#save\x01"|eg;
					$dat->{text}  =~ s|$q|push(@save, "<font color=\"red\">$1</font>"), "\x01$#save\x01"|eg;
				}
			} else {
				my $i=0; foreach my $q (@words) {
					$dat->{title} =~ s|$q|push(@save, "<span class=\"highlight highlight$i\">$1</span>"), "\x01$#save\x01"|eg;
					$dat->{text}  =~ s|$q|push(@save, "<span class=\"highlight highlight$i\">$1</span>"), "\x01$#save\x01"|eg;
					$i++;
				}
			}
			$dat->{title} =~ s/\x01(\d+)\x01/$save[$1]/eg;
			$dat->{text}  =~ s/\x01(\d+)\x01/$save[$1]/eg;
		}
	}
	# static mode ʥ󥯤Х󥯤ˤ
	if ($options->{static_mode}) {
		my $Myself   = $options->{en_Myself};
		my $url      = $options->{en_url};
		my $link_key = $options->{en_elink_key};
		if ($Myself eq '') {
			$Myself = $ROBJ->{Myself};
			$Myself =~ s/([^0-9A-Za-z\x80-\xff])/"\\$1"/eg;
			$options->{en_Myself} = $Myself;	# å
		}
		if ($url eq '') {
			$url = $self->{myself2};
			$url =~ s/([^0-9A-Za-z\x80-\xff])/"\\$1"/eg;
			$options->{en_url} = $url;	# å
		}
		if ($link_key eq '') {
			$link_key = $dat->{elink_key};
			$link_key  =~ s/([^0-9A-Za-z\x80-\xff])/"\\$1"/eg;
			$options->{en_elink_key} = $url;	# å
		}
		# ִ
		my $imgurl = $ROBJ->{Myself} . $self->{public_dir} . "image/" . $diary_id . '/';
		if ($options->{static_html_mode}) {
			$dat->{text} =~ s#(src|href)="${imgurl}#$1="$options->{static_image_dir}#g;
			$dat->{text} =~ s/href="(?:$url(?:$link_key)?)([^\"#]*)/"href=\"$1" . (($1 ne '') ? '.html' : '')/eg;
			$dat->{text} =~ s/(src|href)=\"$Myself/$1="/g;
		} else {
			$dat->{text} =~ s#(src|href)="${imgurl}#$1="$options->{static_image_dir}#g;
			$dat->{text} =~ s/href="(?:$url(?:$link_key)?)/href="/g;
		}
	}
}

#------------------------------------------------------------------------------
# ӸΥ
#------------------------------------------------------------------------------
sub load_diary_for_phone {
	my ($self, $diaries, $set) = @_;
	my $ROBJ = $self->{ROBJ};
	my $logs = $self->load_diary($diaries, $set, '*phone');

	my $tag_escape = $ROBJ->loadpm('TextParser::TagEscape', $self->{phone_allow_tags});
	# ʸURL񤭴󥸥
	my $url_wrapper;
	if ($self->{subdomain_mode}) {
		my $dom = $self->{subdomain_mode};
		$dom =~ s/(\W)/\\$1/g;
		my $reg = qr|^(http://\w+\.$dom)/?(.*)|;
		$url_wrapper = sub {
			my ($type, $url) = @_;
			if ($type ne 'href') { return $url; }
			   if ($url =~ $reg)      { return "$1/\x05$2"; }
			elsif ($url =~ m|^/(.*)|) { return "/\x05$1"; }
			elsif ($url =~ m|^http://(.*)|) { return "http://\x06$1"; }
			return $url;
		};
	} else {
		my $server_url = $ROBJ->{Server_url};
		my $myself  = $ROBJ->{Myself};
		my $myself2 = $ROBJ->{Myself2};
		$url_wrapper = sub {
			my ($type, $url) = @_;
			if ($type ne 'href') { return $url; }
			$url =~ s/^$server_url//;
			$url =~ s|^$myself/?|$myself2\x05|;
			if ($url =~ m|^http://(.*)|) { return "http://\x06$1"; }
			return $url;
		};
	}
	my $pub_dir = $self->{public_dir};
	$pub_dir =~ s/(\W)/\\$1/g;
	my $pub_dir_reg = qr|\x05($pub_dir)|;
	foreach(@$logs) {
		$_->{text} = $tag_escape->escape($_->{text}, $url_wrapper);
		$_->{text} =~ s/$pub_dir_reg/$1/g;
		$_->{text} =~ s/\x05/$self->{phone_query}/g;
		$_->{text} =~ s/\x06/$self->{phone_proxy}/g;
		if ($_->{children_cache} ne '') {
			$_->{children_cache} = $tag_escape->escape($_->{children_cache}, $url_wrapper);
			$_->{children_cache} =~ s/\x05/$self->{phone_query}/g;
			$_->{children_cache} =~ s/\x06/$self->{phone_proxy}/g;
		}
	}
	return $logs;
}
#------------------------------------------------------------------------------
# Ȥ
#------------------------------------------------------------------------------
# $diary_pkey ΥǡʥϥåˤͿƤ褤
#	 Ψɤ
sub load_comments {
	my $self = shift;
	my ($diary_pkey, $displays) = @_;
	my $ROBJ = $self->{ROBJ};
	my $DB   = $ROBJ->{DB};
	# ȿǧ
	if (ref($diary_pkey)) {
		my $d = $diary_pkey;
		$diary_pkey = $d->{pkey};
		if (! $d->{comments_all} || ! $self->{allow_edit} && ! $d->{comments}) {
			return [];		# ʤ
		}
	}

	# ȤΥ
	my $diary_id = $self->{diary_id};
	my %h;
	$h{match_int}    = {diary_pkey => $diary_pkey};
	$h{sort}         = 'tm';
	$h{sort_reverse} = 1;		# 
	if (defined $displays) { $h{limit} = $displays; }
	if (! $self->{allow_edit}) {		# Խ¤ʤ
		$h{flag}  = {enable => 1};	# ɽǽΤ
		$h{cache} = 1;
	}
	my $comments = $DB->select("${diary_id}_comment", \%h);
	$self->{view_comments} = $#$comments +1;

	# սɽ
	if ($self->{daybook_setting}->{comment_sort_reverse}) { return $comments; }
	# 񤭹߽ɽ
	return [ reverse(@$comments) ];
}

#------------------------------------------------------------------------------
# ȥåХå
#------------------------------------------------------------------------------
# $diary_pkey ΥǡʥϥåˤͿƤ褤
#	 Ψɤ
sub load_trackbacks {
	my $self = shift;
	my $ROBJ = $self->{ROBJ};
	my $DB   = $ROBJ->{DB};
	my ($diary_pkey, $displays) = @_;
	# ȥåХåǧ
	if (ref($diary_pkey)) {
		my $d = $diary_pkey;
		$diary_pkey = $d->{pkey};
		if (! $d->{tbs_all} || ! $self->{allow_edit} && ! $d->{tbs}) {
			return [];		# ʤ
		}
	}

	# ȤΥ
	my $diary_id = $self->{diary_id};
	my %h;
	$h{match_int}    = {diary_pkey => $diary_pkey};
	$h{sort}         = 'tm';
	$h{sort_reverse} = 1;		# 񤭹߽
	if (defined $displays) { $h{limit} = $displays; }
	if (! $self->{allow_edit}) {		# Խ¤ʤ
		$h{flag}  = {enable => 1};	# ɽǽΤ
		$h{cache} = 1;
	}
	my $tb_list = $DB->select("${diary_id}_tb", \%h);
	$self->{view_trackbacks} = $#$tb_list +1;

	# 񤭹߽ɽ
	return [ reverse(@$tb_list) ];
}

#------------------------------------------------------------------------------
# 
#------------------------------------------------------------------------------
my @holidays_data = (
	['1989/02/24', '1990/11/12', '1993/06/09'],	# ˡˤ׻ε
	[-2,1],			# 1
	[11],			# 2
	['shunbun'],		# 3
	[29],			# 4
	[3,4,5],		# 5
	[],			# 6
	[-3],			# 7
	[],			# 8
	[-3, 'shubun'],		# 9
	[-2],			# 10
	[3,23],			# 11
	[23]);			# 12

sub generate_calendar {
	my $self = shift;
	my $ROBJ = $self->{ROBJ};
	my $now  = $self->{now};
	my ($st_week, $end_week, $skel_day, $skel_noday, $holiday_class, $year, $mon, $day) = @_;

	if (!defined $year) {
		$year = $self->{calendar_year};
		$mon  = $self->{calendar_mon};
		$day  = $self->{calendar_day};
		if (!defined $year) {
			$year = $now->{year};
			$mon  = sprintf("%02d", $now->{mon});
		}
	}
	#--------------------------------------------------
	# ɽѤ
	#--------------------------------------------------
	my %calendar;
	$calendar{year} = $year;
	$calendar{mon}  = $mon;
	my $cur_yyyymm = $year*100 + $mon;
	my $now_yyyymm = $now->{year}*100 + $now->{mon};
	$self->{this_yyyymm} = $cur_yyyymm;
	if ($self->{exsits_daybook}) {
		if ($cur_yyyymm > 198001) {
			if ($mon == 1) {
				$calendar{prev_year} = $year -1;
				$calendar{prev_mon}  = 12;
			} else {
				$calendar{prev_year} = $year;
				$calendar{prev_mon}  = $mon -1;
			}
			$calendar{prev_yyyymm} = $calendar{prev_year} . sprintf("%02d", $calendar{prev_mon});
		}
		if (1 || $cur_yyyymm < $now_yyyymm) {	# ̤Υɽ̵ѡ
			if ($mon == 12) {
				$calendar{next_year} = $year +1;
				$calendar{next_mon}  = 1;
			} else {
				$calendar{next_year} = $year;
				$calendar{next_mon}  = $mon +1;
			}
			$calendar{next_yyyymm} = $calendar{next_year}. sprintf("%02d", $calendar{next_mon});
		}
	}
	$self->{calendar} = \%calendar;
	my $today = 0;
	if ($cur_yyyymm == $now_yyyymm) {
		$today = $now->{day};
	}

	#--------------------------------------------------
	# Τդ
	#--------------------------------------------------
	my $diary_days = [];
	if ($self->{exsits_daybook}) {	# Ģ¸ߤ
		$diary_days = $self->load_exists_days_in_month( $ROBJ->{DB}, $self->{diary_id}, $cur_yyyymm );
	}

	#--------------------------------------------------
	# 
	#--------------------------------------------------
	my $wday = $self->get_dayweek($year, $mon, 1);
	my $days = $self->get_mdays($year, $mon);

	my @holidays;
	my @day_name;
	if ($holiday_class ne '') {
		my $ary = $holidays_data[$mon];
		foreach(@$ary) {
			my $day  = $_;
			my $name = $ROBJ->message_translate(int($mon) . "/$_");
			if ($day eq 'shunbun') { $day = &get_shunbun($year); }
			if ($day eq 'shubun' ) { $day = &get_shubun ($year); }
			elsif ($_ < 0) {	# ϥåԡޥǡ
				my $x = -5 - $wday + 7*($wday > 1);
				$day = ($_*-7) + $x;
			}
			if ($day > 2 && $holidays[$day-2] && !$holidays[$day-1]) {	# Ƚδ֤ϵ
				$holidays[$day-1] = $ROBJ->message_translate("13/1") || "holiday";
			}
			$holidays[$day] = $name || "holiday";
		}
		my $ary = $holidays_data[0];
		foreach(@$ary) {
			my $day = $_;
			if ($day =~ /^$year\/$mon\/(\d+)$/) {
				$holidays[$1] = $ROBJ->message_translate($day) || "holiday";
			}
		}
	}

	# ɽդΥ饹  day-selected
	my @lines;
	push(@lines, $st_week);
	for(my $i=0; $i<$wday; $i++) {
		push(@lines, $skel_noday);
	}
	my $myself2 = $self->{myself2};
	my $add     = $cur_yyyymm*100;		# ե
	for(my $i=1; $i<=$days; $i++, $wday++) {
		if ($wday == 7) {
			push(@lines, "$end_week$st_week");
			$wday = 0;
		}
		my $c="calendar-day w$wday";
		my $n='';
		if (my $x=$holidays[$i]) {
			$c .= ' ' . $holiday_class;
			if (!$wday) { # ˤξ硢Ρֹ̱νפǤʤ
				my $j=$i;
				while ($holidays[$j]) { $j++; }
				$holidays[$j] = $ROBJ->message_translate("13/2");
			}
			if ($x ne '1') {
				$n=" title=\"$x\"";
			}
		}
		if ($day   == $i) { $c .= ' day-selected'; }
		if ($today == $i) { $c .= ' day-today'; }
		my $d = $i;
		if ($diary_days->[$i]) { $d += $add; $d = "<a href=\"$myself2$d\">$i</a>"; }
		my $z = $skel_day;
		$z =~ s/%c/$c/g;
		$z =~ s/%n/$n/g;
		$z =~ s/%d/$d/g;
		push(@lines, $z);
	}
	for( ;$wday<7; $wday++) {
		push(@lines, $skel_noday);
	}
	push(@lines, $end_week);

	return \@lines;
}

# --- 褽2150ǯ٤ޤǻȤʰ׽ʬʬ׻ ---
sub get_shunbun {
	my $y = $_[0] -2000;
	return int(20.69115 + 0.011 + 0.242194*$y - int($y/4) + int($y/100));
}
sub get_shubun {
	my $y = $_[0] -2000;
	return int(23.10260 - 0.02  + 0.242194*$y - int($y/4) + int($y/100));
}

###############################################################################
# ֥롼
###############################################################################
#------------------------------------------------------------------------------
# ¸ߤΥ
#------------------------------------------------------------------------------
my %Days_cache;
my %Days_cache_tm;
sub load_exists_days_in_month {
	my ($self, $DB, $diary_id, $yyyymm) = @_;
	my $cache_id = "$DB->{db_id}.$diary_id.$yyyymm";
	my $table    = "${diary_id}_diary";
	my $modified = $DB->get_table_lastmodifed( $table );
	# å夬롩
	if ($modified && $modified==$Days_cache_tm{ $cache_id }) { 
		return $Days_cache{ $cache_id };
	}
	# ǡ١
	my %h;
	$h{flag} = {enable   => 1};
	$h{min}  = {yyyymmdd => "${yyyymm}01"};
	$h{max}  = {yyyymmdd => "${yyyymm}31"};
	$h{select_cols} = ['yyyymmdd'];
	my $data = $DB->select($table, \%h);
	my @days;
	foreach(@$data) {
		@days[ substr($_->{yyyymmdd}, -2) ] = 1;
	}
	$Days_cache_tm{ $cache_id } = $modified;
	$Days_cache   { $cache_id } = \@days;
	return \@days;
}

#------------------------------------------------------------------------------
# Ģ
#------------------------------------------------------------------------------
sub load_daybook_setting {
	my ($self, $diary_id) = @_;
	my $ROBJ = $self->{ROBJ};
	$diary_id =~ s/\W//;
	if ($self->{"setting_$diary_id"}) { return $self->{"setting_$diary_id"}; }

	my $file = $ROBJ->get_filepath($self->{setting_dir} . $diary_id . $self->{file_ex});
	$self->{file};
	if (!-e $file) {
		$file = $ROBJ->get_filepath($self->{my_default_setting_file});
		if (!-e $file) {
			$file = $self->{default_setting_file};
		}
	}

	# Υ
	my $set = $self->{"setting_$diary_id"} = $ROBJ->fread_hash_cached($file);
	return $set;
}
#------------------------------------------------------------------------------
# Ģθ
#------------------------------------------------------------------------------
# ѿˡĢ򤷡ꤷ¤ꤹ
sub set_and_select_daybook {
	my ($self, $diary_id) = @_;
	my $ROBJ = $self->{ROBJ};

	# diary_id 
	my $set;
	if ($diary_id ne '') {
		$set = $self->load_daybook_setting( $diary_id );
		$self->{diary_id}        = $diary_id;
		$self->{daybook_setting} = $set;
	}

	# ơޤγǧ
	if (!$self->{phone_mode} && !$ROBJ->{Is_mobile} && exists $set->{theme}) {
		$self->{theme}        = $set->{theme};
		$self->{template_dir} = $set->{template_dir};
	}
	# ȥȤϿ
	my $template_dir = $self->{template_dir} . '_skelton/';
	$template_dir =~ s|[^\w/\-]||g;
	if (-r $ROBJ->get_filepath($template_dir)) { $ROBJ->{User_skelton_dir3}=$template_dir; }
	my $x = $set->{base_template_dir} . '_skelton/';
	$x =~ s|[^\w/\-]||g;
	if (-r $ROBJ->get_filepath($x)) { $ROBJ->{User_skelton_dir2}=$x; }

	$diary_id = $self->{diary_id};	# ºݤ diary_id
	if ($diary_id eq '') { return $set; }
	# 桼CSSγǧ
	my $file = $self->{usercss_dir} . $diary_id . '.css';
	if (-r $ROBJ->get_filepath($file)) { $self->{usercss}=$ROBJ->{Basepath} . $file; }

	# ѤƤǥϢե뤬ʤäƤ
	if ($set->{design_id} ne '') {
		my $check_time = $ROBJ->get_file_lastmodified( $self->{default_design_file} );
		# $ROBJ->message("design [$set->{design_id}] check info:$check_time design_base_tm:$set->{design_base_tm}");
		if ($check_time > $set->{design_base_tm}) {
			$self->design_rebuild( $set->{design_id} );
		}
	}

	# ѹ֤
	my $change_hour = $set->{change_hour_int};
	my $now = $ROBJ->{Now};
	if ($now->{mon}==1 && $now->{day}==1) { $change_hour=0; } # ѹ̵֤
	$ROBJ->{Change_hour} = $change_hour;
	$self->{now} = $ROBJ->time2timehash( $self->{tm} );

	# 
	#    ʬѹ $self->daybook_drop() ѹΤ
	my $auth    = $ROBJ->{Auth};
	my $auth_ok = $auth->{ok};
	my $auth_id = $auth->{id};
	if ($auth_id eq $diary_id || $auth->{admin}) {	# ʬʤ
		$self->{allow_edit}    = 1;
		$self->{allow_com}     = 1;
		$self->{daybook_admin} = 1;
		return $set;
	}
	$self->{allow_edit}    = undef;
	$self->{allow_com}     = undef;
	$self->{daybook_admin} = undef;

	# μɮԽĥ桼Ƚ
	if ($auth_ok) {
		my $admins = $set->{admin_users};
		if ($admins eq '*') {
			$self->{daybook_admin} = 1;
		} elsif ($admins ne '') {
			foreach(split(/\s*,\s*/, $admins)) {
				if ($_ eq $auth_id) { $self->{daybook_admin} = 1; last; }
			}
		}
		my $editors = $set->{edit_users};
		if ($self->{daybook_admin} || $editors eq '*') {
			$self->{allow_edit} = 1;
		} elsif ($editors ne '') {
			foreach(split(/\s*,\s*/, $editors)) {
				if ($_ eq $auth_id) { $self->{allow_edit} = 1; last; }
			}
		}
	}

	# Ȥε
	my $allow_com = $set->{allow_com_user};
	if ($allow_com eq '*' || ($allow_com eq 'user*' && $auth_ok)) {
		$self->{allow_com} = 1;
	} elsif ($allow_com eq 'users' && $auth_ok) {
		foreach(split(/\s*,\s*/, $allow_com)) {
			if ($_ eq $auth_id) { $self->{allow_com}=1; last; }
		}
	}
	return $set;
}

###############################################################################
# սߥ֥롼
###############################################################################
#------------------------------------------------------------------------------
# ջΥåʳǧ
#------------------------------------------------------------------------------
sub check_date {
	my ($self, $year, $mon, $day) = @_;
	if ($year < 1980) { return 'It cannot specify before 1980'; }
	if ($mon < 1 || 12 < $mon) { return 'Illegal month'; }
	if ($day > 0) {
		my $days = $self->get_mdays($year, $mon);
		if ($day < 1 || $days < $day) { return 'Illegal day'; }
	} elsif ($day ne '') { return 'Illegal day'; }
	return ;
}

#------------------------------------------------------------------------------
# μ
#------------------------------------------------------------------------------
sub get_dayweek {
	my $self = shift;
	my ($y, $m, $d) = @_;
	if ($m < 3) { $y--; $m+=12; }
	return ($y + ($y>>2) - int($y/100) + int($y/400) + int((13*$m + 8)/5) + $d) % 7;
}

#------------------------------------------------------------------------------
# 
#------------------------------------------------------------------------------
sub get_mdays {
	my $self = shift;
	my ($year, $m) = @_; # 1  2  3  4  5  6  7  8  9 10 11 12
	my @mdays      = qw(0 31 28 31 30 31 30 31 31 30 31 30 31);
	if ($m != 2)   { return $mdays[$m]; }
	if ($year &   3) { return 28; }	# 4ǳڤʤ
	if ($year % 100) { return 29; }	# 100ǳڤʤ
	if ($year % 400) { return 28; }	# 400ǳڤʤ
	return 29;			# 400ǳڤ
}



1;	# ޤʤ
