#!/usr/local/bin/perl
require 5.004;
use strict;
#------------------------------------------------------------------------------
# ǡݡ for WordPress(xml)
#                                                   (C)2006 nabe / nabe@abk.nu
#------------------------------------------------------------------------------
# WordPress 2.1.x ʹߤ˼줿 XML 
#
package Satsuki::Diary::ImportWordPressXML;
use Time::Local;
###############################################################################
# ܽ
###############################################################################
#------------------------------------------------------------------------------
# ڥ󥹥ȥ饯
#------------------------------------------------------------------------------
sub new {
	my $class = shift;
	my $self  = {};
	bless($self, $class);		# $self 򤳤Υ饹ȴϢդ
	$self->{ROBJ}  = shift;

	return $self;
}

#------------------------------------------------------------------------------
# ڥǥȥ饯
#------------------------------------------------------------------------------
sub DESTROY {
}
###############################################################################
# ǡݡ
###############################################################################
#------------------------------------------------------------------------------
# WordPress(xml)Υǡݡ
#------------------------------------------------------------------------------
sub import {
	my ($self, $diary_obj, $form) = @_;
	my $ROBJ = $self->{ROBJ};
	my $input_coding = 'UTF-8';

	# ǡå
	my $data = $form->{import}->{data};
	delete $form->{import};
	my $check_data = substr($data, 0, 4096);
	if ($check_data !~ m|<!--\s*generator="wordpress/|i) {
		$ROBJ->message('Data format error (%s)', "WordPress(XML) $check_data");
		return -1;
	}

	# ʸѴν
	my $system_coding = $ROBJ->{System_coding};
	my $jcode = $ROBJ->loadpm('Jcode');
	my $title_coding;
	my $body_coding;

	# CDATA
	my @cdata;
	$data =~ s|<!\[CDATA\[(.*?)\]\]>|push(@cdata, $1),"<c$#cdata>"|seg;
	# ȥ꡼
	my @days;
	$data =~ s|<item>(.*?)</item>|push(@days, $1),''|seg;
	undef $data;

	# 
	my $change_hour     = $form->{WPS_change_hour_int};
	my $import_static   = $form->{WPS_import_static};	# Ūڡ򥤥ݡ
	my $static_category = $form->{WPS_static_category};	# Ūڡʬ
	$static_category  ||= $form->{WPS_static_category_input};	# ľܻ
	my $no_auth_com     = $form->{WPS_no_auth};		# ǧȤ򥤥ݡȤʤ
	my $no_spam_com     = $form->{WPS_no_spam};		# SPAMȤ򥤥ݡȤʤ
	#---------------------------------------------------------------------
	# βϤ¸
	#---------------------------------------------------------------------
	my %parser_cache;
	my $days    = 0;
	my $imports = 0;
	foreach my $log (@days) {
		#-------------------------------------------------------------
		# ȡȥåХå
		#-------------------------------------------------------------
		my @comments_data;
		$log =~ s/<wp:comment>(.*?)<\/wp:comment>/push(@comments_data,$1),''/seg;

		#-------------------------------------------------------------
		# ǡβ
		#-------------------------------------------------------------
		my %diary;
		my $day = {};
		$log =~ s|<([\w:]+)>(.*?)</\1>|$day->{$1}=$2,''|seg;
		&xml_decode( $day, \@cdata );
		# 
		my $status = $day->{'wp:status'};
		if ($status eq 'publish' || $status eq 'static' && $import_static) {
			$diary{enable} = 1;
		} elsif ($status eq 'draft' || $status eq 'private') {
			$diary{enable} = 0;
		} else {	# if attachment/object
			next;
		}
		$days++;

		# ȥȥƥʸѴ
		my $title    = $day->{title};
		my $category = $day->{category};
		if ($title_coding eq '') {
			my $str  = $title . $category;
			my $code = $jcode->get_codename(\$str);
			if ($code !~ /ascii/i) { $title_coding=$code; }
		}
		if ($title_coding ne '') {
			$jcode->from_to(\$title,    $title_coding, $system_coding);
			$jcode->from_to(\$category, $title_coding, $system_coding);
		}
		$diary{title}    = $title;
		$diary{category} = $category;

		# վ
		my $gmt = &date2utc($day->{'wp:post_date_gmt'});
		if ($gmt) {
			# ˤĤ
			my $h = $ROBJ->time2timehash( $gmt, $change_hour );
			$diary{year}= $h->{year};
			$diary{mon} = $h->{mon};
			$diary{day} = $h->{day};
			$diary{tm}  = $gmt;
		} elsif ($status eq 'draft') {
			# 顼
			$ROBJ->message('Not set date draft "%s", import to day of "%s"', $diary{title}, '2099-01-01');
			$diary{year}= 2099;
			$diary{mon} = 1;
			$diary{day} = 1;
		} else {
			next;	# 顼
		}
		# /ȥåХåε
		$diary{allow_com} = 0;
		$diary{allow_tb}  = 0;
		if ($day->{'wp:comment_status'} eq 'open') { $diary{allow_com}=1; }
		if ($day->{'wp:ping_status'}    eq 'open') { $diary{allow_tb} =1; }

		#-------------------------------------------------------------
		# ʸνȲù
		#-------------------------------------------------------------
		my $body = $day->{'content:encoded'};
		if ($body =~ /^\s*$/) { next; }
		$body =~ s/\\r\\n|\\r|\\n/\n/g;
		# ʸѴ
		if ($body_coding eq '') {
			my $str  = $body . join('',@comments_data);
			my $code = $jcode->get_codename(\$str);
			if ($code !~ /ascii/i) { $body_coding=$code; }
		}
		if ($body_coding ne '') {
			$jcode->from_to(\$body, $body_coding, $system_coding);
		}
		# ³ɤ൭Υ
		$body =~ s/(\G|\n)====\n/$1 ====\n/g;
		# ³ɤ൭֤
		$body =~ s/(\G|\n)<!--more-->/$1====\n/;
		# ѿ˳Ǽ
		$diary{text}   = $body;
		$diary{parser} = 'simple_p';

		#-------------------------------------------------------------
		# ȡȥåХåβ
		#-------------------------------------------------------------
		my @comments;
		my @trackbacks;
		foreach(@comments_data) {
			my %h;
			my %data;
			$_ =~ s|<wp:comment_(\w+)>(.*?)</wp:comment_\1>|$data{$1}=$2,''|seg;
			&xml_decode( \%data, \@cdata );
			# ʸѴ
			if ($body_coding ne '') {
				foreach(qw(author author_email author_url content)) {
					$data{$_} = $jcode->from_to($data{$_}, $body_coding, $system_coding);
				}
			}
			# վ
			$h{tm} = &date2utc($data{date_gmt});
			# ե饰
			if ($data{approved} eq '1') { $h{enable}=1; } else { $h{enable}=0; }
			# ³ԡƼԾ
			$h{ip}    = $data{author_IP};
			$h{agent} = $data{agent};
			$h{url}   = $data{author_url};
			#-------------------------------------------------------------
			# ʸ
			#-------------------------------------------------------------
			my $body = $data{content};
			# <br> to \n
			$body =~ s/<br.*?>|\\r\\n|\\r|\\n/\n/g;
			# 
			$ROBJ->tag_delete($body);

			if ($body =~ /^\s*$/) { next; }
			if ($data{type} ne 'trackback') {
				#-------------------------------------------------------------
				# Ȥν
				#-------------------------------------------------------------
				$h{name}  = $data{author};
				$h{email} = $data{author_email};
				$h{text}  = $body;	# ʸ
				push(@comments, \%h);
				next;
			}
			#-------------------------------------------------------------
			# ȥåХåν
			#-------------------------------------------------------------
			$h{blog_name} = $data{author};
			if ($body =~ /^(.*?)\.\.\.\n\n(.*)/) {
				$h{title} = $1;
				$body     = $2;
			}
			$body =~ s/ \(more\.\.\.\)$/.../g;	# Ǹ (more...)  ... ֤
			$h{excerpt} = $body;
			push(@trackbacks, \%h);
		}

		#-------------------------------------------------------------
		# ǡ¸
		#-------------------------------------------------------------
		if (! $diary_obj->save_diary(\%parser_cache, \%diary, \@comments, \@trackbacks)) {	# ¸
			$imports ++;
		}
	}
	$diary_obj->{exists_diaries} = $days;
	$diary_obj->{import_diaries} = $imports;
	return 0;
}

###############################################################################
# ֥롼
###############################################################################
#------------------------------------------------------------------------------
# xmlΥ󥳡ɤ᤹
#------------------------------------------------------------------------------
sub xml_decode {
	my ($h, $cdata) = @_;
	while(my ($k,$v) = each(%$h)) {
		if ($v =~ /^<c(\d+)>$/) {
			$v = $cdata->[$1];
		} else {
			$v =~ s/&lt;/</g;
			$v =~ s/&gt;/>/g;
			$v =~ s/&quot;/"/g;
			$v =~ s/&amp;/&/g;
			$v =~ s/&#(\d+);/chr($1)/eg;
		}
		$h->{$k} = $v;
	}
	return $h;
}
#------------------------------------------------------------------------------
# WordPress XMLեǡ UTC Ѵ
#------------------------------------------------------------------------------
#	YYYY-MM-DD hh:mm:ss
sub date2utc {
	my $date = shift;
	my $tz   = shift;
	if ($date !~ /^(\d\d\d\d)-(\d\d)-(\d\d) (\d\d):(\d\d):(\d\d)/) { return ; }
	if ($1 == 0) { return ; }	# ̵
	my $year = $1;
	my $mon  = $2;
	my $day  = $3;
	my $hour = $4;
	my $min  = $5;
	my $sec  = $6;
	return Time::Local::timegm($sec,$min,$hour,$day,$mon-1,$year);
}

1;
