use strict;
#------------------------------------------------------------------------------
# ƥ - ץѡü쥿
#                                                   (C)2006 nabe / nabe@abk.nu
#------------------------------------------------------------------------------
package Satsuki::TextParser::Simple;
our $VERSION = '1.00';
#------------------------------------------------------------------------------
###############################################################################
# ܽ
###############################################################################
#------------------------------------------------------------------------------
# ڥ󥹥ȥ饯
#------------------------------------------------------------------------------
sub new {
	my $class = shift;
	my $self  = {};
	bless($self, $class);   # $self 򤳤Υ饹ȴϢդ
	$self->{ROBJ} = shift;

	return $self;
}

#------------------------------------------------------------------------------
# ڥǥȥ饯
#------------------------------------------------------------------------------
sub DESTROY {
}

###############################################################################
# ᥤ롼
###############################################################################
#------------------------------------------------------------------------------
# ʸ
#------------------------------------------------------------------------------
sub text_parser {
	my ($self, $lines) = @_;
	if (ref($lines) eq 'ARRAY') {
		foreach(@$lines) { chomp($_); }
	} else {
		$lines = [ split(/\n/, $lines) ];
	}

	# simpleѡ
	$lines = $self->simple_parser($lines);

	# sectionղ
	if ($self->{div_section}) {
		unshift(@$lines, "<div class=\"section\">\n");
		push   (@$lines, "</div>\n");
	}

	return join('', @$lines);
}

###############################################################################
#  ץѡü쥿ʤ
###############################################################################
sub simple_parser {
	my ($self, $lines) = @_;
	# 
	my $thisurl      = $self->{thisurl};
	my $see_more_msg = $self->{seemore_msg};
	# 
	my $br_mode = $self->{br_mode};
	my $p_mode  = $self->{paragraph_mode};
	my $p_class = $self->{paragraph_class};
	my $ls_mode = $self->{ls_mode};		# Դֽ⡼
	my $indent  = $self->{indent};
	# p class
	$p_class =~ s/[^\w\-]//g;
	if ($p_class ne '') { $p_class = " class=\"$p_class\""; }

	# ե饰
	my $in_paragraph = 0;
	my $see_more     = 0;
	my $ls_count     = 0;	# ԥ

	my @ary;
	push (@ary, "<div class=\"entry_body entry-body\">\n");
	my ($prev_f, $this, $this_f, $next, $next_f);
	push(@$lines, '');
	foreach(@$lines) {
		$prev_f = $this_f;
		$this = $next; $this_f = $next_f;
		$next = $_;    $next_f = 0;
		if ($next eq '') { $next_f=1; }
		if (!defined $this) { next; }
		#----------------------------------------------------
		# ³ɤɽ
		#----------------------------------------------------
		if (! $see_more && ($next eq '====' || $next eq '=====')) { $next_f=-1; }
		if ($this_f == -1) {
			push(@ary, <<MORE_TEXT);
</div>
<!--%msg--><a class="seemore" href="$thisurl">$see_more_msg</a></p><!--%msg--><!--%more-->
<div class="entry-more entry_more">
MORE_TEXT
			$see_more=1;
			$ls_count=0;
			next;
		}
		# ==== Υɽ
		$this =~ s/^ =/=/;
		# -- 򥨥
		if ($see_more) { $this =~ s/--/&#45;-/g; }	# ȡSee More '--' 򥨥
		#----------------------------------------------------
		# Խ
		#----------------------------------------------------
		if ($this eq '') {
			if (! $ls_mode) { next; }
			# Խ⡼
			$ls_count++;
			if ($ls_count>1) { push(@ary, "$indent<br />\n"); }
			next;
		}
		$ls_count = 0;	# ԥ󥿽
		#----------------------------------------------------
		# λϤޤꡩ
		#----------------------------------------------------
		# ԡᣱ
		if ($p_mode==1) {
			push(@ary, "$indent<p$p_class>$this</p>\n");
			next;
		}
		# ʤ
		if (! $p_mode)  {
			if ($br_mode) { push(@ary, "$indent$this<br>\n"); }    # Խ
				else  { push(@ary, "$indent$this\n");     }
			next;
		}
		# ʻ
		if ($p_mode!=2) { next; }

		# Ԥ
		my $head = '';
		my $foot = '';
		# λϤޤ
		if (! $in_paragraph) { $head = "<p$p_class>"; $in_paragraph=1; }
		# ν
		if ($next_f) {
			$in_paragraph=0;
			$foot='</p>';
		# Ԥ
		} elsif ($br_mode) {
			$foot='<br />';
		}
		# 
		push(@ary, "$indent$head$this$foot\n");
	}
	# ³ɤɽ
	push(@ary, "</div>\n");
	if ($see_more) { push(@ary, "<!--%more-->\n"); }

	return \@ary;
}


###############################################################################
# 
###############################################################################


1;
