use strict;
#------------------------------------------------------------------------------
# ˡץ饰
#                                                   (C)2006 nabe / nabe@abk.nu
#------------------------------------------------------------------------------
package Satsuki::TextParser::TagPlugin::Tag_calc;
###############################################################################
# ܽ
###############################################################################
#------------------------------------------------------------------------------
# 󥹥ȥ饯
#------------------------------------------------------------------------------
sub new {
	my $class = shift;	# ɤ߼Τ
	my $ROBJ  = shift;	# ɤ߼Τ
	my $tags  = shift;
	$tags->{"calc"}   = {data => \&calc};
	$tags->{"calcx"}  = {data => \&calcx};
	$tags->{"poland"} = {data => \&calc};
}

###############################################################################
# 롼
###############################################################################
#------------------------------------------------------------------------------
# calcˡ
#------------------------------------------------------------------------------
sub calc {
	my ($parser_obj, $tag, $cmd, $ary) = @_;
	my $ROBJ = $parser_obj->{ROBJ};

	my $exp = shift(@$ary);
	# β
	my @str_buf;
	my $r = &convert_reversed_poland( $ROBJ, \@str_buf, $exp );
	if (! ref($r)) { return $r; }
	if ($cmd eq 'poland') {
		my @a = grep { $_ ne '%a' } @$r;
		return join(' ', @a);
	}
	# ɾ
	my $r = &evaluate_poland( $ROBJ, $parser_obj->{x}, \@str_buf, $r );
	$exp =~ s/\"//g;
	$exp =~ s/\(/&#40;/g;
	return "<span class=\"calc\" title=\"$exp\">$r</span>";
}
sub calcx {	# ͤʤ
	&calc(@_);
	return '';
}

###############################################################################
# 
###############################################################################
#------------------------------------------------------------------------------
# 黻Ҿ
#------------------------------------------------------------------------------
my %operators;	# ͥ
my %operation;	# ¹Խ
# bit 0 - 麸
# bit 1 - ñ黻
# bit 2 - դϥ֥Ȥ
# bit 3 - ñ黻
# bit 412 - 黻ͥ
$operators{'('}  =  0x00;
$operators{')'}  =  0x00;
$operators{'%a'} =  0x00;	# 㳰
$operators{'%r'} =  0x00;	# 㳰
$operators{';'}  =  0x00;	# 㳰
$operators{','}  =  0x10;	# 㳰
$operators{'='}  =  0x25; $operation{'='}  = sub { $_[0]->{$_[1]}   = $_[2]; }; 
$operators{'+='} =  0x25; $operation{'+='} = sub { $_[0]->{$_[1]}  += $_[2]; };
$operators{'-='} =  0x25; $operation{'-='} = sub { $_[0]->{$_[1]}  -= $_[2]; };
$operators{'*='} =  0x25; $operation{'*='} = sub { $_[0]->{$_[1]}  *= $_[2]; };
$operators{'/='} =  0x25; $operation{'/='} = sub { $_[0]->{$_[1]}  /= $_[2]; };
$operators{'%='} =  0x25; $operation{'%='} = sub { $_[0]->{$_[1]}  %= $_[2]; };
$operators{'%.='}=  0x25; $operation{'%.='}= sub { $_[0]->{$_[1]}  .= $_[2]; };
$operators{'**='}=  0x25; $operation{'**='}= sub { $_[0]->{$_[1]} **= $_[2]; };
$operators{'^='} =  0x25; $operation{'^='} = sub { $_[0]->{$_[1]} **= $_[2]; };
$operators{'<<='}=  0x25; $operation{'<<='}= sub { $_[0]->{$_[1]} <<= $_[2]; };
$operators{'>>='}=  0x25; $operation{'>>='}= sub { $_[0]->{$_[1]} >>= $_[2]; };
$operators{'&='} =  0x25; $operation{'&='} = sub { $_[0]->{$_[1]}  &= $_[2]; };
$operators{'|='} =  0x25; $operation{'|='} = sub { $_[0]->{$_[1]}  |= $_[2]; };
$operators{'&&='}=  0x25; $operation{'&&='}= sub { $_[0]->{$_[1]} &&= $_[2]; };
$operators{'||='}=  0x25; $operation{'||='}= sub { $_[0]->{$_[1]} ||= $_[2]; };
$operators{'||'} =  0x30; $operation{'||'} = sub { $_[0] || $_[1]; };
$operators{'&&'} =  0x40; $operation{'&&'} = sub { $_[0] && $_[1]; };
$operators{'|'}  =  0x50; $operation{'|'}  = sub { $_[0] |  $_[1]; };
#$operators{'^'}  =  0x60; $operation{'^'}  = sub { $_[0] ^  $_[1]; };
$operators{'&'}  =  0x70; $operation{'&'}  = sub { $_[0] &  $_[1]; };
$operators{'=='} =  0x80; $operation{'=='} = sub { $_[0] == $_[1]; };
$operators{'!='} =  0x80; $operation{'!='} = sub { $_[0] != $_[1]; };
$operators{'<=>'}=  0x80; $operation{'<=>'}= sub { $_[0] <=> $_[1]; };
$operators{'%e'} =  0x80; $operation{'%e'} = sub { $_[0] eq $_[1]; };
$operators{'%n'} =  0x80; $operation{'%n'} = sub { $_[0] ne $_[1]; };
$operators{'<'}  =  0x90; $operation{'<'}  = sub { $_[0] <  $_[1]; };
$operators{'>'}  =  0x90; $operation{'>'}  = sub { $_[0] >  $_[1]; };
$operators{'<='} =  0x90; $operation{'<='} = sub { $_[0] <= $_[1]; };
$operators{'>='} =  0x90; $operation{'>='} = sub { $_[0] >= $_[1]; };
$operators{'%d'} =  0xa2; $operation{'%d'} = sub { defined $_[0]; };
$operators{'>>'} =  0xb0; $operation{'>>'} = sub { $_[0] >> $_[1]; };
$operators{'<<'} =  0xb0; $operation{'<<'} = sub { $_[0] << $_[1]; };
$operators{'+'}  =  0xc0; $operation{'+'}  = sub { $_[0] +  $_[1]; };
$operators{'-'}  =  0xc0; $operation{'-'}  = sub { $_[0] -  $_[1]; };
$operators{'%.'} =  0xc0; $operation{'%.'} = sub { $_[0] .  $_[1]; };
$operators{'*'}  =  0xd0; $operation{'*'}  = sub { $_[0] *  $_[1]; };
$operators{'/'}  =  0xd0; $operation{'/'}  = sub { $_[0] /  $_[1]; };
$operators{'%'}  =  0xd0; $operation{'%'}  = sub { $_[0] %  $_[1]; };
$operators{'%x'} =  0xd0; $operation{'%x'} = sub { $_[0] x  $_[1]; };
$operators{'%+'} =  0xee; $operation{'%+'} = sub { ($_[0]->{$_[1]})++; };
$operators{'%-'} =  0xee; $operation{'%-'} = sub { ($_[0]->{$_[1]})--; };
$operators{'%++'}=  0xe6; $operation{'%++'}= sub { ++($_[0]->{$_[1]}); };
$operators{'%--'}=  0xe6; $operation{'%--'}= sub { --($_[0]->{$_[1]}); };
$operators{'!'}  =  0xf2; $operation{'!'}  = sub { ! $_[0]; };
$operators{'~'}  =  0xf2; $operation{'~'}  = sub { ~ $_[0]; };
$operators{'^'}  = 0x100; $operation{'^'}  = sub { $_[0] ** $_[1]; };
$operators{'**'} = 0x100; $operation{'**'} = sub { $_[0] ** $_[1]; };
$operators{'#'}  = 0x200; $operation{'#'}  = sub { $_[0]->[ $_[1] ]; };	# դ⡩
$operators{'%m'} = 0x202; $operation{'%m'} = sub { - $_[0]; };

#------------------------------------------------------------------------------
# ؿ
#------------------------------------------------------------------------------
my %functions;
$functions{'sin'}  = sub { sin($_[0]) };
$functions{'cos'}  = sub { cos($_[0]) };
$functions{'tan'}  = sub { sin($_[0])/cos($_[0]) };
$functions{'asin'} = sub { atan2($_[0] / sqrt(1 - $_[0] * $_[0]), 1) };
$functions{'acos'} = sub { atan2(sqrt(1 - $_[0] * $_[0]) / $_[0], 1) };
$functions{'atan'} = sub { atan2($_[0], 1) };
$functions{'atan2'}= sub { atan2($_[0], $_[1]) };
$functions{'rand'} = sub { rand($_[0]) };
$functions{'oct'}  = sub { oct($_[0]) };
$functions{'hex'}  = sub { hex($_[0]) };
$functions{'abs'}  = sub { ($_[0] < 0) ? -$_[0] : $_[0] };
$functions{'ln'}   = sub { log($_[0]) };		# п
$functions{'log'}  = sub { log($_[0])/log(10) };	# п
$functions{'exp'}  = sub { exp($_[0]) };
$functions{'sqrt'} = sub { sqrt($_[0]) };
$functions{'pow'}  = sub { $_[0] ** $_[1] };
$functions{'sqr'}  = $functions{'sqrt'};
$functions{'root'} = $functions{'sqrt'};

$functions{'floor'} = sub { int($_[0]) };
$functions{'round'} = sub { int($_[0]+0.5) };
$functions{'ceil'}  = sub { (int($_[0]) != $_[0]) ? ($_[0]+1) : $_[0] };
$functions{'int'}   = $functions{'floor'};
$functions{'rint'}  = $functions{'round'};
$functions{'cint'}  = $functions{'round'};
$functions{'ceiling'}=$functions{'ceil'};

$functions{'max'} = sub { my $x=shift(@_); ($x<$_) && ($x=$_) foreach(@_); $x; };
$functions{'min'} = sub { my $x=shift(@_); ($x>$_) && ($x=$_) foreach(@_); $x; };

$functions{'pow10'}  = sub { 10 ** $_[0] };
$functions{'log10'}  = $functions{'log'};
$functions{'log2'}   = sub { log($_[0])/log(2) };
$functions{'hypot'}  = sub { sqrt($_[0] * $_[0] + $_[1] * $_[1]) };
$functions{'fabs'}   = $functions{'abs'};
$functions{'fma'}    = sub { $_[0] * $_[1] + $_[2] };
$functions{'remainder'} = sub { $_[0] - int(&{$functions{'round'}}($_[0] / $_[1])) * $_[1] };
$functions{'ldexp'}  = sub { $_[0] * (2 ** $_[1]) };
$functions{'scalb'}  = sub { $_[0] * ($_[1] ** $_[2]) };

$functions{'rad2deg'}= sub { $_[0] * 180 / 3.14159265358979323846 };
$functions{'def2rag'}= sub { $_[0] * 3.14159265358979323846 / 180 };


#--- ״ؿ --------------------------
$functions{'time'}      = sub { time() };
$functions{'localtime'} = sub {
	my %h;
	$h{tm} = $_[0];
	( $h{sec},  $h{min},  $h{hour},
	  $h{_day}, $h{_mon}, $h{year},
	  $h{wday}, $h{yday}, $h{isdst}) = localtime($_[0]);
	$h{year} +=1900;
	$h{_mon} ++;
	return \%h;
};

#--- ʸؿ ------------------------
$functions{'substr'} = sub { substr($_[0], $_[1], $_[2]) };
$functions{'ord'}    = sub { ord(@_) };
$functions{'length'} = sub { length(@_) };
$functions{'index'}  = sub { index ($_[0], $_[1], $_[2]) };
$functions{'rindex'} = sub { rindex($_[0], $_[1], $_[2]) };
$functions{'chop'}   = sub { chop (@_) };
$functions{'chomp'}  = sub { chomp(@_) };
$functions{'regexp'}  = sub { $_[0] =~ /$_[1]/; };
$functions{'replace'} = sub { $_[0] =~ s/$_[1]/$_[2]/g };
$functions{'split'} = sub { my $x=shift; [ split(/$x/, @_) ] };
$functions{'join'}  = sub {
	my $x = shift; my $y = $_[0];
	if (ref($y) eq 'ARRAY') { return join($x, @$y) }
	join($x, @_);
};
$functions{'crypt'}  = sub { crypt($_[0], $_[1]) };

#--- ؿ --------------------------
$functions{'push'} = sub { my $ary=shift; push(@$ary, @_) };
$functions{'pop'}  = sub { pop(@{ $_[0] }) };
$functions{'unshift'} = sub { my $ary=shift; unshift(@$ary, @_) };
$functions{'shift'}   = sub { shift(@{ $_[0] }) };
$functions{'sort'}    = sub {[ sort {$a <=> $b} (ref($_[0]) ? @{ $_[0] } : @_) ]};
$functions{'strsort'} = sub {[ sort {$a cmp $b} (ref($_[0]) ? @{ $_[0] } : @_) ]};
$functions{'reverse'} = sub {[ reverse (ref($_[0]) ? @{ $_[0] } : @_) ]};

#--- ʬ --------------------------
$functions{'if'} = sub { $_[0] ? $_[1] : $_[2] };




###############################################################################
# 
###############################################################################
#------------------------------------------------------------------------------
# եݡɵˡѴ
#------------------------------------------------------------------------------
sub convert_reversed_poland {
	my ($ROBJ, $str, $cmd) = @_;
	# ʸ
	$cmd =~ s/\x00-\x03//g;
	$cmd =~ s/\"((?:\\.|[^\"])*)\"/push(@$str, $1), "\x01$#$str\x01"/eg;
	foreach(@$str) {
		$_ =~ s/\$([\w\.]+)/\x02$1\x02/g;	# ѿִɾ
		$_ =~ s/\$\[([\w\.]+)\]/\x02$1\x02/g;	# ѿִɾ
		$_ =~ s/\\(.)/$1/g;			# \ 
	}
	$cmd =~ s/\'([^\']*)\'/push(@$str, $1), "\x01$#$str\x01"/eg;

	# ѴΤִ
	$cmd =~ s/(\W)\.([^\w=])/$1%.$2/g;	# ʸϢ
	$cmd =~ s/\.=/%.=/g;			# ʸϢ
	$cmd =~ s/(\W)eq(\W)/$1%e$2/g;		# ʸ
	$cmd =~ s/(\W)ne(\W)/$1%n$2/g;		# ʸ
	$cmd =~ s/(\W)defined(\W)/$1%d$2/g;	# 
	# $cmd =~ s/(\W)x(\W)/$1%x$2/g;		# ʸ x n
	$cmd =~ s/\+\+/%+/g;			# ++
	$cmd =~ s/\-\-/%-/g;			# --
	$cmd =~ s/\s//g;			# 
	$cmd =~ s/\(\)/(undef)/g;		# func() ν

	# ʸ
	# my $z = $cmd; $z =~ s/\e/|/g; print "\n*** $z\n";	# debug
	my @op  = ('(');	# 黻ҥå
	my @opl = ( 0 );	# åα黻ͥ ¸
	my @poland;		# եݡɵˡϿ
	my $x = $cmd . ')';
	my $right_arc = 0;
	while ($x =~ /(.*?)([=,\(\)\+\-<>\^\*\/&|%!;\#\@])(.*)/s) {
		if ($1 ne '') { push(@poland,  $1); }	# 黻Ҥμ
		my $op  = $2;
		if (length($3) >1 && $operators{$op . substr($3, 0, 2)}) {	# 3ʸα黻ҡ
			$op .= substr($3, 0, 2);
			$x   = substr($3, 2);	# Ĥ
		} elsif ($3 ne '' && $operators{$op . substr($3, 0, 1)}) {	# 2ʸα黻ҡ
			$op .= substr($3, 0, 1);
			$x   = substr($3, 1);	# Ĥ
		} else {
			$x = $3;		# Ĥ
		}
		if (!$right_arc && $1 eq '') {	# 黻Ҥľ ) ǤʤǤʤ
			if ($op eq '-') { $op = '%m'; }	# ͤɽȽ
			elsif ($op eq '%+' || $op eq '%-') {	# ++/--
				$op .= substr($op, 1, 1);	# %+/%-()  %++/%--֡
			}
		}
		# 黻ͥ٤Фbit 0 ϱͥȽ̤ΤȤ˻ѡ
		my $opl = $operators{$op};
		#
		# $op  ɤ߹黻
		# $opl 黻ͥ
		# $1   黻Ҥ
		#
		if ($op eq '(') {
			push(@op, '('); push(@opl, 0);
			if ($1 eq '') {		# Τä
				push(@op, '%a');
				push(@opl, 0);
			} else {		# xxxxxx() δؿ¹
				push(@op, '%r');
				push(@opl, 0);
			}
		} else {
			my $z = $opl & 1;	# ͥξ $z = 1
			if ($opl & 8) {	# ñ黻Ҥʤ
				push(@poland, $op);
				$right_arc = -1;	# ̰
				next;
			} elsif ($opl[$#opl] & $opl & 2) {	# åȥåפȸ黻ҤƱñ黻
				# ͥ٤˴طʤ黻ҤФʤ
			} else {
				while ($#opl>=0 && $opl[$#opl] >= $opl + $z) {
					my $op0   = pop(@op);
					my $level = pop(@opl);
					if ($op0 eq '(') { last; }	# '(' ξ硢λ
					# 黻Ҥͥ٤㤤黻Ҥ
					push(@poland, $op0);	# եݡɵˡ
				}
			}
			# 黻ҤѤ
			if ($op eq ')') {
				$right_arc = 1;
			} else {
				$right_arc = 0;
				push(@op,  $op);
				push(@opl, $opl);
			}
		}
		# print "poland exp.   : ", join(' ', @poland), "\n";
		# print "op stack dump : ", join(' ', @op), "\n";
	}
	#
	# Ѵλ
	#
	if ($x ne '' || $#op >= 0) {	# Ĥäʸ or 黻ҥåǧ
		return  "expression error";	# 顼
	}
	return \@poland;
}

#------------------------------------------------------------------------------
# եݡɵˡ eval Ѵ
#------------------------------------------------------------------------------
sub evaluate_poland {
	my ($ROBJ, $vars, $str, $pol) = @_;

	# 
	$vars->{PI} ||= 3.14159265358979323846;
	$vars->{e}  ||= 2.71828182845905;
	my @types = map { &get_element_type($_) } @$pol;

	# ñִ <@t.var> 
	if ($#$pol == 0 && $types[0] eq 'obj') { return &get_object($pol->[0]); }
	# ñִ
	if ($#$pol == 0 && $types[0] eq 'const') { return $pol->[0]; }

	# ʣ
	my @stack;
	my @stack_type;
	my $i = 0;
	foreach my $p (@$pol) {
		## print "  dump stack : ", join(' ', @stack), "\n";
		## print "  type stack : ", join(' ', @stack_type), "\n";
		my $type = $types[$i++];		# 
		if ($type eq 'op') {			# 黻
			my $op  = $p;
			my $opl = $operators{$p};
			my $opf = $operation{$p};	# ؿ
			## printf("\top = $op [%x]\n", $opl);

			my $x  = pop(@stack);
			my $xt = pop(@stack_type);
			if (!defined $x) { last; }	# 顼
			if ($xt eq 'obj' && ($opl & 6)!=6) { $x = &get_object($x); }
			if (ref($x) eq 'ARRAY') { $x = pop(@$x); }
			if ($opf) {
				if ((~$opl) & 2) {	# 黻
					# $y (op) $x
					my $y  = pop(@stack);
					my $yt = pop(@stack_type);
					if (!defined $y) { last; }	# 顼
					if (ref($y) eq 'ARRAY') { $y = pop(@$y); }
					if ($opl & 4) {		# ե֥Ϥ
						if ($yt ne 'obj') { push(@stack, $yt); last; }	#顼
						my ($obj, $name) = &get_object_sep($y);
						eval { $x = &$opf($obj, $name, $x); };
						if ($@) { return $@; }
					} else {
						if ($yt eq 'obj') { $y = &get_object($y); }
						eval { $x = &$opf($y, $x); };
						if ($@) { return $@; }
					}
				} elsif ($opl & 4) {	# ñ黻, ե֥Ϥ
					if ($xt ne 'obj') { push(@stack,$xt); last; }	#顼
					my ($obj, $name) = &get_object_sep($x);
					eval { $x = &$opf($obj, $name); };
					if ($@) { return $@; }
				} else {	# ñ黻
					$x  = &$opf($x);
				}
				push(@stack, $x);
				push(@stack_type, 'const');
				next;
			}
			#
			# ߥ
			#
			if ($op eq ';')  {
				if (@stack) {	# ɤ߼Τ
					pop(@stack);
					pop(@stack_type);
				}
				push(@stack,      $x);
				push(@stack_type, $xt);
				next;
			}
			#
			# ޽
			#
			if ($op eq '%a') {	# %a(a, b, c, ...);
				my @x2 = split("\x03,", $x);
				if ($#x2 > 0) { $x = \@x2; $xt='array'; }
				push(@stack,      $x);		# 
				push(@stack_type, $xt);
				next;
			}
			if ($op ne ',' && $op ne '%r') { next; }
			my $y  = pop(@stack);
			my $yt = pop(@stack_type);
			if ($op eq ',')  {
				if ($yt eq 'obj') { $y = &get_object($y); }
				push(@stack,      "$y\x03,$x");
				push(@stack_type, 'array');
				next;
			}
			#
			# ؿ¹
			#
			if ($y eq 'array') {	# array(a, b, c, ...);
				$x = [ split("\x03,", $x) ];
				push(@stack,     $x);		# 
				push(@stack_type, 'array');
				next;
			} elsif ($yt eq 'obj') {
				if ($y eq 'clear') {		# ؿ
					$_[0] = $vars = {};
					push(@stack,      undef);
					push(@stack_type, 'const');
					next;
				}
				my $func = $functions{$y};
				if (! ref($func)) {	# 顼
					return "Unknown function '$y'";
				}
				if ($xt eq 'array') {	# 
					$x = [ split("\x03,", $x) ];
				} else {
					$x = [$x];
				}
				eval { $x = &$func(@$x); };
				if ($@) { $x="Error [$@]"; }
				push(@stack,      $x);
				push(@stack_type, '*');
			} else {	# 顼
				push(@stack,      $y);
				push(@stack_type, $yt);
				last;
			}
			next;

		} elsif ($type eq 'error') {	# 顼
			push(@stack,      $p);
			push(@stack_type, $type);
			last;

		} elsif ($type eq 'string') {	# ʸ
			$p =~ s/\x01(\d+)\x01/$str->[$1]/;
			$p =~ s/\x02([\w\.]+)\x02/ &get_object($1) /eg;
			push(@stack,      $p);
			push(@stack_type, 'const');
		} else {	# ֥Ȼʤ
			push(@stack,      $p);
			push(@stack_type, $type);
		}
	}

	if ($#stack != 0) {
		return "expression error($#stack) $stack[0] $stack[1] $stack[2] $stack[3]";	# 顼Ԥִ
	}
	my $exp  = pop(@stack);
	my $type = pop(@stack_type);
	if ($type eq 'obj') { return &get_object($exp); }	# ֥ξɾ
	$exp =~ s/^.*\x03,([^\x03]*?)$/$1/;	# , ξǸͤȤ
	return $exp;

	#------------------------------------------------------------------------------
	# ̾饪֥Ȥμ
	#------------------------------------------------------------------------------
	sub get_object {
		my ($obj, $name) = &get_object_sep(@_);
		return $obj->{$name};
	}
	sub get_object_sep {
		my ($name) = @_;
		$name =~ s/[^\w\.]//g;		# Ⱦѱѿ _ . ʳʸ
		if ($name eq '') { return 'undef'; }	# 顼̤򼨤֥Ȥ֤

		my @ary = split(/\./, $name);
		my $obj  = $vars;
		my $last = pop(@ary);
		foreach $name (@ary) {
			$obj = $obj->{$name};
		}
		return ($obj, $last);
	}
}

#-----------------------------------------------------------
# Ǥμ
#-----------------------------------------------------------
sub get_element_type {
	my $p = $_[0];
	if (exists $operators{$p}) { return 'op'; }		# 黻
	if ($p =~ /^\x01\d+\x01$/)   { return 'string'; }	# ʸʲùʤ
	if ($p =~ /[^\w\.]/)         { return 'error'; }	# ʸ󡿥顼
	if ($p =~ /^[\d\.]+$/ || $p =~ /^0x[\dA-Fa-f]+$/) { return 'const'; }	# ͡ʲùʤ
	if ($p =~ /^(\d+)\.\w+$/) {		# դο  10.is_cache_on ʤ
		$_[0] = $1; return 'const';
	}
	if ($p =~ /^yes$/i || $p =~ /^true$/i) {
		$_[0] = 1; return 'const';
	}
	if ($p =~ /^no$/i || $p =~ /^false$/i) {
		$_[0] = 0; return 'const';
	}
	if ($p =~ /^new(|\..*)$/) {
		if ($1 eq '' || $1 eq '.hash') { $_[0] = '{}'; return 'hash';  }
		if ($1 eq '.array')            { $_[0] = '[]'; return 'array'; }
		$_[0] = ''; return 'error';
	}
	if ($p eq 'undef') { $_[0]=undef; return 'const'; }

	return 'obj';
}

1;
