use strict;
#------------------------------------------------------------------------------
# ˡץ饰
#                                                   (C)2006 nabe / nabe@abk.nu
#------------------------------------------------------------------------------
package Satsuki::TextParser::TagPlugin::Tag_image;
###############################################################################
# ܽ
###############################################################################
# Ȥ
#   ̾εˡץ饰Ȱ㤤ץʸˤ image 
# ꤹ뤳ȤǻѤ롣
# 
#
#	img       = , image, 1, http://image.xxx.jp/image/$1_small.jpg
#	img#large = , image, 1, http://image.xxx.jp/image/$1_large.jpg
#	img#link  = , image, 1, http://image.xxx.jp/image/$1.jpg
#large ʤɤΥ㤤ꤹݤϡοƱˤ뤳ȡ
#  $11 顢ǽ˽ФƤ "." μޤǤִ
#
# ȤȤ
# [img:test]
#   <a href="http://image.xxx.jp/image/test.jpg" class="img">
#	<img alt="test" title="test" src="http://image.xxx.jp/image/test_large.jpg"></a>
#
# [img:test:small]
#   <a href="http://image.xxx.jp/image/test.jpg" class="img small">
#	<img alt="test" title="test" src="http://image.xxx.jp/image/test_small.jpg"></a>
#
# [img:test:Ƥ]
#   <a href="http://image.xxx.jp/image/test.jpg" class="img">
#	<img alt="Ƥ" title="Ƥ" src="http://image.xxx.jp/image/test_small.jpg"></a>
#
#------------------------------------------------------------------------------
# 󥹥ȥ饯
#------------------------------------------------------------------------------
sub new {
	my $class = shift;	# ɤ߼Τ
	my $ROBJ  = shift;	# ɤ߼Τ

	my $tags  = shift;
	$tags->{'=image'} = \&image;
}
###############################################################################
# 롼
###############################################################################
#------------------------------------------------------------------------------
# imageˡ
#------------------------------------------------------------------------------
sub image {
	my ($parser_obj, $tag, $cmd, $ary) = @_;
	my $tags = $parser_obj->{tags};
	my $ROBJ = $parser_obj->{ROBJ};
	my $replace_data = $parser_obj->{replace_data};

	# mode å
	my $tag_name = $tag->{name};
	my $argc     = $tag->{argc};
	my $mode     = $ary->[ ($argc || 1) ];
	if (exists $tags->{"$tag_name#$mode"}) {
		$tag  = $tags->{"$tag_name#$mode"};
		$mode = undef;
	}

	#  
	my $url  = $tag->{data};
	my $link = $url;
	if (exists $tags->{"$tag_name#link"}) { $link = $tags->{"$tag_name#link"}->{data}; }
	# URL
	if (! $argc) {	#Ŀʤ
		$argc = 1;
		$url .= '$1';
	}
	my @argv  = splice(@$ary, 0, $argc);
	my @argv2 = @argv;
	$ROBJ->tag_escape(@argv2);
	my $name = $argv2[$#argv2];
	unshift(@argv,  $ROBJ->{Basepath});
	$url  =~ s/\$(\d)/$argv[$1]/g;			# ʸѴ
	$link =~ s/\$(\d)/$argv[$1]/g;
	$url  =~ s/\$\{(\w+)\}/$replace_data->{$1}/g;	# Ǥեǡִ
	$link =~ s/\$\{(\w+)\}/$replace_data->{$1}/g;
	if ($url =~ /\$\$/) {	# ִ
		shift(@argv);
		my $str = join(':', @argv);
		$url  =~ s/\$\$/$str/g;
		$link =~ s/\$\$/$str/g;
	}

	# 
	my $size;
	if    ($mode =~ /^w(\d+%?)$/) { $size=" width=\"$1\"";  shift(@$ary); }
	elsif ($mode =~ /^h(\d+%?)$/) { $size=" height=\"$1\""; shift(@$ary); }
	elsif (!defined $mode) { shift(@$ary); }	# ⡼ɻɤ߼Τ

	# °
	my %tag2 = %$tag; 
	$tag2{title}='';	# altƱˤ
	my $attri = $parser_obj->make_attri($ary, \%tag2, 'image');
	   $name  = $parser_obj->make_name ($ary, $name);

	# 󥯹
	if ($link eq '') {	# 󥯤ʤ
		return "<img title=\"$name\" alt=\"$name\"$size src=\"$url\" class=\"$tag->{class}\">";
	}
	return "<a title=\"$name\" href=\"$link\"$attri><img alt=\"$name\"$size src=\"$url\"></a>";
}



1;
