use strict;
#------------------------------------------------------------------------------
# timeˡץ饰
#                                                   (C)2006 nabe / nabe@abk.nu
#------------------------------------------------------------------------------
package Satsuki::TextParser::TagPlugin::Tag_time;
###############################################################################
# ܽ
###############################################################################
#------------------------------------------------------------------------------
# 󥹥ȥ饯
#------------------------------------------------------------------------------
sub new {
	my $class = shift;	# ɤ߼Τ
	my $ROBJ  = shift;	# ɤ߼Τ
	my $tags = shift;
	$tags->{time}  = {data => \&tag_time};
	$tags->{utc}   = {data => \&tag_utc};
}

###############################################################################
# 롼
###############################################################################
#------------------------------------------------------------------------------
# timeˡ
#------------------------------------------------------------------------------
sub tag_time {
	my ($parser_obj, $tag, $cmd, $ary) = @_;
	my $ROBJ = $parser_obj->{ROBJ};

	my $time = $parser_obj->{thistm} || $ROBJ->{TM};	# 񤭹
	if ($ary->[0] > 0) { $time = shift(@$ary); }

	my $str = join(':', @$ary);
	$str = $ROBJ->tm_printf($str, $time);
#	return "<span class=\"$tag->{class}\" title=\"UTC $time\">$str</span>";
	return $str;
}

#------------------------------------------------------------------------------
# utcˡ
#------------------------------------------------------------------------------
sub tag_utc {
	my ($parser_obj, $tag, $cmd, $ary) = @_;
	my $ROBJ = $parser_obj->{ROBJ};

	my $str = join(':', @$ary);
	if ($str eq '') { return $ROBJ->{TM}; }

	my $year = $parser_obj->{thisyear};
	my $mon  = $parser_obj->{thismon};
	my $day  = $parser_obj->{thisday};
	my $hour = 0;
	my $min  = 0;
	my $sec  = 0;
	if ($str =~ m|(\d+)/(\d+)/(\d+)|) {
		if ($3 > 2000) { $year=$3; $mon=$1; $day=$2; }
			  else { $year=$1; $mon=$2; $day=$3; }
	} elsif ($str =~ m|(\d+)/(\d+)|) {
		$mon=$1; $day=$2;
	}
	if ($str =~ /(\d+):(\d+)(?::(\d+))?/) {
		$hour=$1; $min=$2; $sec=int($3);
	}
	# ѿĴ
	if ($year > 1900) { $year -= 1900; } elsif ($year < 100) { $year+=100; }
	require Time::Local;
	my $utc = 'Error';
	eval { $utc = Time::Local::timegm($sec,$min,$hour,$day,$mon-1,$year); };
	
	# return "<span class=\"$tag->{class}\" title=\"$str\">$UTC</span>";
	return $utc;
}

1;
