use strict;
#------------------------------------------------------------------------------
# ƥ tDiaryߴѡ
#                                                   (C)2006 nabe / nabe@abk.nu
#------------------------------------------------------------------------------
package Satsuki::TextParser::tDiary;
our $VERSION = '1.00';
#------------------------------------------------------------------------------
###############################################################################
# ܽ
###############################################################################
#------------------------------------------------------------------------------
# ڥ󥹥ȥ饯
#------------------------------------------------------------------------------
sub new {
	my $class = shift;
	my $self  = {};
	bless($self, $class);   # $self 򤳤Υ饹ȴϢդ
	$self->{ROBJ} = shift;

	return $self;
}

#------------------------------------------------------------------------------
# ڥǥȥ饯
#------------------------------------------------------------------------------
sub DESTROY {
}

###############################################################################
# ᥤ롼
###############################################################################
#------------------------------------------------------------------------------
# ʸ
#------------------------------------------------------------------------------
sub text_parser {
	my ($self, $lines) = @_;
	if (ref($lines) eq 'ARRAY') {
		foreach(@$lines) { chomp($_); }
	} else {
		$lines = [ split(/\n/, $lines) ];
	}

	# tDiaryߴѡ
	$lines = $self->tDiary_parser($lines);

	return join("\n", @$lines);
}

###############################################################################
# tDiaryߴѡ
###############################################################################
sub tDiary_parser {
	my ($self, $lines) = @_;
	# 
	my $in_section      =0;
	my $section_count   =0;
	my $subsection_count=0;
	# ͤΥ
	my $section_anchor    = $self->{section_anchor}    || '_';
	my $subsection_anchor = $self->{subsection_anchor} || '_';
	my $anchor_name_base  = $self->{anchor_name_base}  || 'p';
	my $thisurl = $self->{thisurl};
	my $section_anchor    = '<span class="sanchor">' . $section_anchor    . '</span>';
	my $subsection_anchor = '<span class="sanchor">' . $subsection_anchor . '</span>';

	my @ary;
	my @section;
	push(@$lines, '');	# ɬsectionĤ뤿ղ
	while(@$lines) {
		my $line = shift(@$lines);
		#----------------------------------------------------
		# ü쥿ִ
		#----------------------------------------------------
		$line =~ s/<%=(isbn.+?)%>/$self->amazon($1)/eg;
		
		#----------------------------------------------------
		# Ǥ
		#----------------------------------------------------
		if ($in_section) {
			if ($line eq '') {	# ν
				if ($in_section > 0) {	# <p> 
					foreach(@section) { $_ = "<p>$_</p>"; }
				}
				push(@ary, @section);
				push(@ary, "</div> <!-- end section -->\n");
				@section = ();
				$in_section=0;
				next;
			}
			push(@section, $line);
			# '<'ǻϤޤԤ硢<p>ʤ
			if (ord($line) == 0x3c) { $in_section=-1; }
			next;
		}
		#----------------------------------------------------
		# 
		#----------------------------------------------------
		if ($line eq '') { next; }
		#----------------------------------------------------
		# λϤޤ
		#----------------------------------------------------
		$in_section = 1;
		push(@ary, '<div class="section">');
		my $s1 = substr($line, 0, 1);
		my $s2 = substr($line, 0, 2);
		if ($s1 eq '<' && $s2 ne '<<') {	# tagʥ(pػ)
			$in_section = -1;
			push(@ary, $line);	# Τޤ޽
			next;
		}
		# 󥫥󥿤
		$subsection_count++;	# ֥
		my $anchor = $subsection_anchor;
		$anchor =~ s/%d/$section_count/g;
		$anchor =~ s/%s/$subsection_count/g;
		my $sec_name = "$anchor_name_base$section_count\.$subsection_count";

		if ($s1 eq ' ') {		# ƬȾѥڡ
			$line = substr($line, 1);
			push(@ary, "<p><a name=\"$sec_name\" href=\"$thisurl#$sec_name\">$anchor</a> $line</p>");
			next;
		}
		if ($s2 eq '') {		# Ƭѥڡ
			$line = substr($line, 2);
			push(@ary, "<p><a name=\"$sec_name\" href=\"$thisurl#$sec_name\">$anchor</a> $line</p>");
			next;
		}
		# ʳϡ󥿥ȥ
		$section_count++;	# ֹ+1
		$subsection_count = 0;	# ֥
		my $anchor = $section_anchor;
		$anchor =~ s/%d/$section_count/g;
		my $sec_name = $anchor_name_base . $section_count;
		if ($s2 eq '<<') {		# tagʥ֥ȥ
			$line = substr($line, 1);
			push(@ary, "<h3 class=\"subtitle\"><a name=\"$sec_name\" href=\"$thisurl#$sec_name\">$anchor</a> $line</h3>");
			next;
		}
		push(@ary, "<h3 class=\"subtitle\"><a name=\"$sec_name\" href=\"$thisurl#$sec_name\">$anchor</a> $line</h3>");
	}

	return \@ary;
}


###############################################################################
# ץ饰ѥĥ
###############################################################################
#------------------------------------------------------------------------------
# amazon.rb εǽ
#------------------------------------------------------------------------------
# See more info --> http://docs.tdiary.org/ja/?amazon.rb
#	<%=isbn_image_left "asin", "comment"%>
#	<%=isbn_image_right "asin", "comment"%>
#	<%=isbn_image "asin", "comment"%>
#	<%=isbn "asin", "comment"%>
sub amazon {
	my $self = shift;
	my $tag  = shift;

	$tag =~ /^isbn_?(\w*) "(\w+)"(.*)/;
	my $image = $1;
	my $asin  = $2;
	my $x     = $3;
	my $comment = "ASIN:$asin";
	if ($x =~ /,\s*"(.*?)"/) { $comment=$1; }

	# ͥ
	my $asid = $self->{asid};
	if ($asid ne '') { $asid .= '/ref=nosim'; }
	if (substr($image, 0, 5) ne 'image') {
		return "<a href=\"http://www.amazon.co.jp/exec/obidos/ASIN/$asin/$asid\">$comment</a>";
	}

	# ᡼
	my $size = $self->{size};
	my $ext  = '.09.MZZZZZZZ.jpg';	# midium
	   if ($size eq 'large') { $ext = '.09.LZZZZZZZ.jpg'; }
	elsif ($size eq 'small') { $ext = '.09.THUMBZZZ.jpg'; }

	my $class = substr($image, 5) || 'amazon';
	$class =~ s/\W//g;

	return "<a href=\"http://www.amazon.co.jp/exec/obidos/ASIN/$asin/$asid\"><img class=\"$class\" src=\"http://images.amazon.com/images/P/$asin$ext\" alt=\"$comment\" title=\"$comment\"></a>";
}


1;
