require 5.004;
use strict;
#------------------------------------------------------------------------------
# Album - for AutoLoader
#------------------------------------------------------------------------------
use Satsuki::Uploader ();
package Satsuki::Uploader;
###############################################################################
# ¸
###############################################################################
#------------------------------------------------------------------------------
# Ŀʥեꥹˤ¸
#------------------------------------------------------------------------------
sub save_user_info {
	my ($self) = @_;
	my $ROBJ = $self->{ROBJ};
	$ROBJ->fwrite_hash( $self->{user_info_file}, $self->{user_info} );
}

###############################################################################
# եॢν
###############################################################################
#------------------------------------------------------------------------------
# եκ
#------------------------------------------------------------------------------
sub mkfolder {
	my $self = shift;
	my $ROBJ = $self->{ROBJ};
	my $folder_name = shift;
	if (! $self->{allow_upload}) {
		$ROBJ->message("Operation not permitted");
		return 1;
	}
	if ($self->make_currentfolder()) { return 1; }	# 
	if ($self->{max_depth} && $self->{max_depth} <= $self->{currentfolder_depth}) {
		$ROBJ->message("Too deep folder (max depth : %s)", $self->{max_depth});
		return 2;
	}

	# ǥ쥯ȥ
	$folder_name =~ s/^\.+//;	# Ƭ . 
	my $dir = $self->{user_dir}.$self->{currentfolder}.$folder_name;
	if ((my $r=$ROBJ->mkdir($dir)) != 1) {
		if ($r == -1) { $ROBJ->message("'%s' alreday exists", $folder_name); }
		return -1;
	}
	# եι
	$self->update_folderlist();
	return 0;	# 
}

#------------------------------------------------------------------------------
# եΰư
#------------------------------------------------------------------------------
sub mvfolder{
	my $self = shift;
	my $ROBJ = $self->{ROBJ};
	my $move_to = shift;

	if (! $self->{allow_upload}) {
		$ROBJ->message("Operation not permitted");
		return 1;
	}
	my $dir = $self->{user_dir_path};	# ¥ѥ

	if ($self->make_currentfolder()) { return 2; }	# 
	my $name = $self->{currentfolder};
	if ($name =~ /\/([^\/]+)\/$/) { $name = $1; }
	if ($name eq '') {
		$ROBJ->message('[Move] failed: %s', $name);
		return 3;
	}

	# ưγǧ
	$move_to =~ s|/\.+|/.|g;	# /..  /. ˡʤɻߡ
	if ($move_to ne '') {
		$move_to =~ s|/*$|/|;	#  / 1Ĥˤ
	}
	if(-r "$dir$move_to$name"){
		$ROBJ->message('[Move] failed: "%s" already exists', "$move_to$name");
		return 4;
	}

	# ư
	if(! rename($dir.$self->{currentfolder}, "$dir$move_to$name")){
		$ROBJ->message('[Move] failed: %s', "$move_to$name");
		return 5;
	}

	# եι
	$self->update_folderlist();

	# 
	$self->{url} = $self->{myself2}.$move_to.$name;
	return 0;
}

#------------------------------------------------------------------------------
# ե̾ѹ
#------------------------------------------------------------------------------
sub rename{
	my $self  = shift;
	my $ROBJ  = $self->{ROBJ};
	my $cpath = shift;
	my $from  = shift;
	my $to    = shift;
	my $thumb_dir = $self->{thumbnail_dir};

	if (! $self->{allow_upload}) {
		$ROBJ->message("Operation not permitted");
		return 1;
	}

	# ե̾ΰǧ
	$cpath =~ s|/+|/|g;
	$cpath =~ s|/\.+|/.|g;	# /..  /.
	if ($cpath ne '') { $cpath =~ s|/*$|/|; }	#  / 1Ĥˤ
	$cpath = $self->{user_dir_path} . $cpath;

	$from =~ s|/||g;	# ե̾ / 
	$to   =~ s|/||g;	# ե̾ / 

	# ĥҤγǧ
	if ($self->check_file_ex($to)) {
		return 10;
	}

	# եΰưγǧ
	# javascriptǳǧѤ...ʤǰΤ
	if($from eq $to){	# ưȰư
		$ROBJ->message('[Rename] Same file names (source, destination) are assignment');
		return 2;
	}

	# ե뤬ˤ롩
	if(-e $cpath.$to){
		$ROBJ->message('[Rename] failed: "%s" already exists', $to);
		return 3;
	}

	# եΰư
	if(! rename("$cpath$from", "$cpath$to")){
		$ROBJ->message('[Rename] failed: %s', $to);
		return 4;
	}
	if(! rename("$cpath$thumb_dir$from.jpg", "$cpath$thumb_dir$to.jpg")){
		# ͥϤ뤫ɤ狼ʤ
	}

	# å
	$ROBJ->message('[Rename] success');
	return 0;
}

#------------------------------------------------------------------------------
# եΰư
#------------------------------------------------------------------------------
sub move{ return &mmove(@_); }
sub mmove{
	my $self  = shift;
	my $ROBJ  = $self->{ROBJ};
	my $from  = shift;
	my $to    = shift;
	my $files = shift;
	if (!ref $files) { $files=[$files]; }

	if (! $self->{allow_upload}) {
		$ROBJ->message("Operation not permitted");
		return 1;
	}

	# %Υǥ
	$from =~ s/%([0-9a-fA-F][0-9a-fA-F])/chr(hex($1))/eg;
	$to   =~ s/%([0-9a-fA-F][0-9a-fA-F])/chr(hex($1))/eg;
	# ѥΰǧ
	$from =~ s|[\x00-\x1f]| |g;
	$to   =~ s|[\x00-\x1f]| |g;
	$from =~ s|/+|/|g;
	$to   =~ s|/+|/|g;
	$from =~ s|/\.+|/.|g;	# /..  /.
	$to   =~ s|/\.+|/.|g;	# /..  /.
	if ($from ne '') { $from =~ s|/*$|/|; }	#  / 1Ĥˤ
	if ($to   ne '') { $to   =~ s|/*$|/|; }	#
	$from = $self->{user_dir_path} . $from;
	$to   = $self->{user_dir_path} . $to;

	# եΰưγǧ
	# javascriptǳǧѤ...ʤǰΤ
	if($from eq $to){	# ưȰư
		$ROBJ->message('[Move] Same folders (source, destination) are assignment');
		return 2;
	}

	# ư褬Ȣ
	my $prefix = '';
	if($self->{trashbox_dir} ne '' && $to eq $self->{user_dir_path}.$self->{trashbox_dir}){
		my($sec, $min, $hour, $mday, $mon, $year) = localtime();
		$prefix = sprintf("%04d%02d%02d_%02d%02d", $year+1900, $mon, $mday, $hour, $sec);
	}

	# 缡եư
	my $count_f=0;	# Կ
	my $count_s=0;	# 
	my $thumb_dir = $self->{thumbnail_dir};
	foreach(@$files) {
		$_ =~ s|/||g;	# ե̾ / 
		if ($_ eq '') { next; }

		# ե뤬ˤ롩
		if(-e "$to$prefix$_"){
			$ROBJ->message('[Move] failed: "%s" already exists', $_);
			$count_f++; next;
		}
		# եΰư
		if(! rename("$from$_", "$to$prefix$_")){
			$ROBJ->message('[Move] failed: %s', $_);
			$count_f++; next;
		}
		$ROBJ->mkdir("$to$thumb_dir");
		if(! rename("$from$thumb_dir$_.jpg", "$to$thumb_dir$prefix$_.jpg")){
			# ͥϤ뤫ɤ狼ʤ
		}
		$count_s++;
	}
	# å
	if ($count_s) { $ROBJ->message('[Move] success: %s file(s)', $count_s); }
	if($count_f > 0){
		$ROBJ->message('[Move] failed: %s', $count_f);
	}
	return $count_f;
}

#------------------------------------------------------------------------------
# եΥåץ
#------------------------------------------------------------------------------
# ñե
#---------------------------------------
sub upload {
	my $self = shift;
	my $ROBJ = $self->{ROBJ};
	if (! $self->{allow_upload}) {
		$ROBJ->message("Operation not permitted");
		return 1;
	}
	# ǥ쥯ȥ
	if ($self->make_currentfolder()) { return 2; }	# 
	# åץɤθƤӽФ
	return $self->do_upload(@_);
}

#---------------------------------------
# ʣեΥåץ
#---------------------------------------
sub mupload {
	my $self = shift;
	my $ROBJ = $self->{ROBJ};
	my $form = shift;
	if (! $self->{allow_upload}) {
		$ROBJ->message("Operation not permitted");
		return 1;
	}
	# ǥ쥯ȥ
	if ($self->make_currentfolder()) { return 2; }	# 

	# ͥ륵μ
	my $thumbnail_size = int($form->{thumbnail_size});

	# ˥åץ
	my $num = $form->{num};
	if ($num > 99) { $num=99; }
	my $count_s = 0;
	my $count_f = 0;
	for(my $i = 1; $i <= $num; $i++){
		my $file_hash = $form->{"filedata$i"};
		if ($file_hash->{file_name} eq '' || $file_hash->{file_size} < 1) {
			next;
		}
		$file_hash->{thumbnail_data} = $form->{"thumb$i"};
		$file_hash->{thumbnail_size} = $thumbnail_size;

		# åץ
		my $res = $self->do_upload( $file_hash );
		if($res){ $count_f++; next; } # 
		$count_s++;
	}

	# å
	if ($count_s) {
		$ROBJ->message('[Upload] success: %s file(s)', $count_s);
	}
	if($count_f > 0){
		$ROBJ->message('[Upload] fail: %s file(s)', $count_f);
	}
	return 0;
}

#----------------------------------------------------------------------
# åץɤμ½
#----------------------------------------------------------------------
# Diary/Mail_post.pm ľܸƤФ
sub do_upload {
	my $self = shift;
	my $ROBJ = $self->{ROBJ};
	my $file_hash = shift;
	my $save_hash = shift;
	if (!ref($save_hash)) { $save_hash = $self; }

	# ϥåǡʥեǡγǧ
	my $file_name = $file_hash->{file_name};
	my $file_size = $file_hash->{file_size};
	my $tmp_file  = $file_hash->{tmp_file};		# ɤ߹եǡ(tmp file)
	$file_name =~ s|^\.+||;				# Ƭ . ν
	$file_name =~ s|[\x00-\x1f/]| |g;		# 楳ɤ / 򥹥ڡ1Ĥ֤
	if ($file_name eq '' || $file_size < 1) {
		$ROBJ->message("Upload file error : %s", $file_name);
		return 2;
	}

	# ĥҥå
	my $file_ex;
	if ($file_name =~ /\.([^\.]+)$/) { $file_ex = $1; }
	$file_ex =~ tr/A-Z/a-z/;

	my $is_image = $self->{allow_ex_img_hash}->{$file_ex} ? 1 : 0;
	if ($self->check_file_ex($file_name)) { 
		return 3;
	}

	# ե¸
	my $dir      = $self->{user_dir}     .$self->{currentfolder};
	my $dir_path = $self->{user_dir_path}.$self->{currentfolder};
	my $save_file      = $dir . $file_name;
	my $save_file_path = $dir_path . $file_name;
	if (-e $save_file_path) {	# Ʊե뤬¸ߤ
		if ((-s $save_file_path) != $file_size) {	# ե륵ƱʤСƱȸʤ
			$ROBJ->message('Save failed ("%s" already exists)', $file_name);
			return 10; # Diary/Mail_post.pm ͤ򻲾ȡѹԲġ
		}
	} else {
		my $fail;
		if ($tmp_file) {
			if (! rename($tmp_file, $save_file_path)) {
				$ROBJ->message("File can't write '%s'", "$dir$file_name");
				$fail=-1;
			}
		} else {
			if ($ROBJ->fwrite_lines($save_file, $file_hash->{data})) { $fail=-2; }
		}
		if ($fail) { return $fail; }	# ¸

		# ȡExifκ
		if ($self->{strip_comment} && $is_image && !$self->load_image_magick()) {
			my $image = Image::Magick->new;
			$image->Read($save_file_path);
			eval {
				$image->Strip();
			};
			if ($@) {	# ImageMagick-5.x.xξStrip᥽åɤϻȤʤ
				$image->Comment(undef);
				$image->Profile(profile=>undef);
			}
			$image->Write($save_file_path);
			undef $image;
		}
	}

	#----------------------------------------------------------------------
	# ѿ¸
	#----------------------------------------------------------------------
	$save_hash->{file_dir}  = $self->{currentfolder};
	$save_hash->{file_full} = $save_file;
	$save_hash->{file_name} = $file_name;
	$save_hash->{file_size} = $file_size;
	$save_hash->{is_image}  = $is_image;
	#----------------------------------------------------------------------
	# 
	#----------------------------------------------------------------------
	my %h;
	$h{i} = $self->{diary_id};
	$h{b} = $ROBJ->{Basepath};
	$h{u} = $self->{image_dir};
	$h{d} = $self->{currentfolder};
	$h{f} = $file_name;
	$h{e} = $file_ex;
	$h{s} = $file_size;
	$h{h} = $ROBJ->{Server_url};
	$h{'%'} = '%';

	my $tag = $self->{upload_tag};
	if (! $is_image) {	# ʳ
		$self->{upload_file} = $self->{upload_file_full};
		$self->{upload_file} =~ s/%(\w)/$h{$1}/g;
		$self->{upload_file} =~ s/([\"\'<>])/'%' . unpack('H2',$1)/eg;
		$tag = $self->{upload_tag_etc};
	}
	# $ROBJ->uri_encode( $h{f}, $h{e} );	# ܸե̾
	$tag =~ s/%(\w)/$h{$1}/g;
	$save_hash->{tag_orig} = $tag;	# ꥸʥΥ
	$save_hash->{tag}      = $tag;

	#----------------------------------------------------------------------
	# ͥ
	#----------------------------------------------------------------------
	my $thumb_dir  = $self->{thumbnail_dir};
	my $thumb_hash = $file_hash->{thumbnail_data};
	my $thumb_file      = $dir     .$thumb_dir.$file_name.".jpg";
	my $thumb_file_path = $dir_path.$thumb_dir.$file_name.".jpg";
	my $fail=0;
	if (ref($thumb_hash)) {
		# åץɤ줿ե򥵥ͥȤ֤
		my $tmp_file = $thumb_hash->{tmp_file};		# ɤ߹եǡ(tmp file)
		# ¹
		if ($thumb_hash->{file_name} eq '' || $thumb_hash->{file_size} < 1) {
			$fail = -1;
		} elsif ($tmp_file) {
			$ROBJ->mkdir($dir_path.$thumb_dir);
			if (! rename($tmp_file, $thumb_file_path)) { $fail=1; }
		} else {
			$ROBJ->mkdir($dir_path.$thumb_dir);
			if ($ROBJ->fwrite_lines($thumb_file, $thumb_hash->{data})) { $fail=2; }
		}
		if ($fail > 0) {	# ¸
			$ROBJ->message('Thumbnail file save failed : %s', "${file_name}.jpg");
		}
	}
	if ($fail || !ref($thumb_hash)) {
		$fail = $self->make_thumbnail($save_file_path, $thumb_file_path, $file_ex, $file_hash->{thumbnail_size});
	}
	# 
	if ($fail){
		# $self->{thumbnail_file} = $self->{album_icons} . $self->{nothumb};
		# $thumbnail_file = $self->{album_icons} . $self->{nothumb};
	} elsif ($is_image) {
		# ͥ륿
		$tag = $self->{upload_tag_thumbnail};
		$tag =~ s/%(\w)/$h{$1}/g;
		$save_hash->{tag} = $tag;
	}
	return 0;	# 
}


#------------------------------------------------------------------------------
# Ȣˤ
#------------------------------------------------------------------------------
sub clear_trashbox {
	my $self = shift;
	my $ROBJ = $self->{ROBJ};
	my $dir  = $self->{user_dir}.$self->{trashbox_dir};

	# ȢꤵƤʤ
	if($self->{trashbox_dir} eq ''){
		return 0;
	}

	# ȢȺ
	$ROBJ->dir_delete( $dir );

	# Ȣ
	$ROBJ->mkdir( $dir );
	$ROBJ->message("[Trashbox] Erase all files in the %s", $self->{trashbox_name});

	# եι
	$self->update_folderlist();
	return 0;
}

###############################################################################
# ֥롼
###############################################################################
#------------------------------------------------------------------------------
# Υͥ
#------------------------------------------------------------------------------
# make_thumbnail() Ƥ֤!!in Uploader.pm
sub make_thumbnail_image {
	my $self = shift;
	my $orig_file  = shift;		# ¥ѥǤ뤳!!
	my $thumb_file = shift;		# ¥ѥǤ뤳!!
	my $file_ex    = shift;
	my $size       = shift || $self->{thumbnail_size};
	my $ROBJ = $self->{ROBJ};

	if ($self->load_image_magick()) { return -1; }
	my $image;
	eval { 
		$image = Image::Magick->new;
		$image->Read( $orig_file );
		$image = $image->[0];
	};
	if ($@) { return -1; }	# load 
	$image->Set( quality => ($self->{jpeg_quality} || 70) );

	# ꥵ
	if ($size < 16)  { $size=120; }
	if (999 < $size) { $size=999; }
	my ($width, $height) = $image->Get('width', 'height');
	if ($width<$size && $height<$size) {
		$size = 0;	# resize ʤ
	} elsif ($width > $height) {
		$height = int($height*($size/$width));
		$width  = $size;
	} else {
		$width  = int($width*($size/$height));
		$height = $size;
	}
	if ($size) {	# ꥵ
		eval { $image->Thumbnail(width => $width, height => $height); };
		if ($@) {	# ImageMagick-5.x.xξThumbnail᥽åɤϻȤʤ
			eval { $image->Resize(width => $width, height => $height, blur => 0.7);	};
			if ($@) { return -2; }	# ͥ
 		}
	}

	# ǥ쥯ȥ
	if ($thumb_file =~ m|(.*)/[^/]+$|) {
		my $dir = $1;
		$ROBJ->mkdir($dir);
	}
	# ե˽񤭽Ф
	$image->Write($thumb_file);
	if ($ROBJ->{File_mode}) { chmod($ROBJ->{File_mode}, $thumb_file); }

	return 0;	# 
}
#------------------------------------------------------------------------------
# ¾ΥեΥͥ
#------------------------------------------------------------------------------
# make_thumbnail() Ƥ֤!!in Uploader.pm
sub make_thumbnail_etc {
	my $self = shift;
	my $orig_file  = shift;		# ¥ѥǤ뤳!!
	my $thumb_file = shift;		# ¥ѥǤ뤳!!
	my $file_ex    = shift;
	my $size       = shift || $self->{thumbnail_size};
	my $ROBJ = $self->{ROBJ};

	if ($self->load_image_magick()) { return -1; }
	my $image = Image::Magick->new;
	$image->Set( quality => 100 );	# ʸߤԹ̵Ǻ

	# ꤵ줿120x120ξǥͥ
	if($size > 120){ $size = 120; }
	if(999 < $size){ $size = 999; }
	my $fontsize = $self->{fontsize};
	if($fontsize<0){ $fontsize = 12; }

	$image->Set(size=>"${size}x${size}");
	$image->ReadImage('xc:white');

	# 
	my $font = $ROBJ->get_filepath($self->{font});
	if($self->{font} && -r $font){
		my $file_name = $orig_file;
		if ($file_name =~ /\/([^\/]+)$/) { $file_name = $1; }
		my $filesize  = (stat($orig_file))[7];
		my $ch = 'byte';
		$filesize =~ s/(\d{1,3})(?=(?:\d\d\d)+(?!\d))/$1,/g;
		my $timestamp = $ROBJ->tm_printf("%Y/%m/%d %H:%M:%S", (stat($orig_file))[9]);

		my $jcode = $ROBJ->loadpm("Jcode");
	 	my $text = "$file_name\r\n$filesize $ch\r\n$timestamp";
		$text = $jcode->from_to($text, $ROBJ->{System_coding}, 'UTF-8');

		$image->Annotate(text=>$text, font=>$font, x=>3, y=>80, pointsize=>$fontsize);
	} else {
		undef $font;
	}

	# ĥҤ˹碌ƥƹ
	my $ext_icon = $self->{etc_icons}->{'.'};
	if(exists( $self->{etc_icons}->{$file_ex})){
		$ext_icon = $self->{etc_icons}->{$file_ex}
	}
	$ext_icon = $ROBJ->get_filepath($self->{album_icons}.$ext_icon);
	if(-r $ext_icon){
		my $icon = Image::Magick->new;
		eval {
			$icon->Read( $ext_icon );
			$icon = $icon->[0];
		};
		if ($@) { last; }	# load 
		my ($width, $height) = $icon->Get('width', 'height');
		$width  = ($size - $width) / 2;

		if($font){
			$height = (64 - $height) / 2;
		}else{
			$height = ($size - $height) / 2;
		}

		if($height < 0){ $height = 0; }
		$image->Composite(image=>$icon, compose=>'Over', x=>$width, y=>$height);
	}

	# ǥ쥯ȥ
	if ($thumb_file =~ m|(.*)/[^/]+$|) {
		my $dir = $1;
		$ROBJ->mkdir($dir);
	}
	# ե˽񤭽Ф
	$image->Write($thumb_file);
	if ($ROBJ->{File_mode}) { chmod($ROBJ->{File_mode}, $thumb_file); }

	return 0;
}

#------------------------------------------------------------------------------
# åץɥեκ
#------------------------------------------------------------------------------
# Diary/Mail_post.pm ľܸƤФ
sub make_currentfolder {
	my $self = shift;
	my $ROBJ = $self->{ROBJ};
	my $pinfo = $ROBJ->{Pinfo};

	my $user_dir = $self->{user_dir_path};
	my $cur_dir  = $self->{currentfolder};
	my $alias = $self->{alias};
	my $subdir="";
	my $depth = 0;
	my $makes = 0;
	foreach(@$pinfo) {
		if ($_ eq '') { last; }
		if($self->{max_depth} > 0 && $depth++ >= $self->{max_depth}){
			$ROBJ->message("Too deep folder (max depth : %s)", $self->{max_depth});
			return ;
		}
		my $dir = "$_/";
		# Ƭ . 
		if ($dir ne $self->{trashbox_dir}) {
			$dir =~ s/^\.+//;
		}
		# ǥ쥯ȥ
		$subdir .= $dir;
		if ($ROBJ->mkdir("$user_dir$subdir")==1) { $makes++; }
	}
	# ɽ˥ե򹹿뤿ˡͤõ
	# Diary/Mail_post.pm ľܸƤФ뤿᥹ȥƤӽФԲ
	if ($makes) {
		$self->{user_info}->{dir_list} = undef;
		$self->{user_info}->{dir_html} = undef;
		$self->save_user_info();
	}
	# ѿκ
	$self->set_currentfolder();

	if (!-e "$user_dir$cur_dir") { return 1; }
	return 0;
}

#------------------------------------------------------------------------------
# եꥹȥեι
#------------------------------------------------------------------------------
sub update_folderlist {
	my $self = shift;
	my $ROBJ = $self->{ROBJ};

	my @dirlist;
	my $out = $ROBJ->call($self->{folderlist_skelton}, \@dirlist);

	# ¸
	my $key = ($self->{show_fullpath})? "pathname" : "name";
	$self->{user_info}->{dir_list} = join("", map {"$_->{$key}\t$_->{path}\n"} @dirlist);
	$self->{user_info}->{dir_html} = $ROBJ->chain_array( $out );
	$self->save_user_info();
	return 0;
}

#----------------------------------------------------------
# եꥹȤΥɡʥȥ󢬤ƤФ
#----------------------------------------------------------
sub search_folderlist {
	my $self = shift;
	my $basedir  = shift;
	my $subdir   = shift;
	my $pathname = shift;
	my $ROBJ = $self->{ROBJ};

	my $list = $ROBJ->search_files("$basedir$subdir", "", -1);
	my $alias = $self->{alias};
	my @new_list;
	foreach(@$list) {
		my $dir  = "$_/";
		my $path = $subdir.$dir;
		my $name = $alias->{"$_/"};
		if (defined $name) {
			if ($name eq '') { next; }	# ̾ʸʤɽʤ
			push(@new_list, {"name"=>$name, "pathname"=>"$pathname$name", "dir"=>$dir, "path"=>$path, "alias"=>1});
			next;
		}
		if ($_ =~ /^\./) { next; }	# .xxx ɽʤ(alias˻äƤʤ)
		$name = $dir;
		$ROBJ->tag_escape($name);
		push(@new_list, {"name"=>$name, "pathname"=>"$pathname$name", "dir"=>$dir, "path"=>$path});
	}
	# 
	@new_list = sort {$a->{alias} <=> $b->{alias} || $a->{name} cmp $b->{name}} @new_list;

	return \@new_list;
}

#------------------------------------------------------------------------------
# ĥҤΥå
#------------------------------------------------------------------------------
sub check_file_ex {
	my $self = shift;
	my $filename = shift;
	my $ROBJ = $self->{ROBJ};

	my @file_ex = ('');
	if ($filename =~ /\.(.+)$/) {
		my $x = $1;
		$x =~ tr/A-Z/a-z/;
		@file_ex = split(/\./, $x);
	}

	my $allow_ex_img = $self->{allow_ex_img_hash};	# 
	my $allow_ex_etc = $self->{allow_ex_etc_hash};	# ʳ
	my $etc = $self->{allow_ex_etc};

	foreach(@file_ex) {
		if (! $allow_ex_img->{$_}
		   && defined $etc && defined $etc->[0] && !$allow_ex_etc->{$_}) {
			# ¾γĥҤ졢ĵʤĥ
			$ROBJ->message("File extension not allow : %s", $_);
			return 1;
		}
	}
	return 0;
}



1;
