////////////////////////////////////////////////////////////////////////////////
// ݡȥӥ塼
//   Copyright(C) 2008 ꤫/꤫
////////////////////////////////////////////////////////////////////////////////

album.view.ReportView = {
	create: function(view) {
	var tbl = document.createElement('table');
		tbl.id = view.id+'_tbl';
		tbl.className = 'report_view';
		view.appendChild(tbl);

	var th  = document.createElement('thead');
	var r, n, s, d;
		r   = document.createElement('tr'); r.className = 'report_header';
		n   = document.createElement('th'); n.innerHTML = 'Name';
			r.appendChild(n);
		s   = document.createElement('th'); s.innerHTML = 'Size'; s.className = 'numsort';
			r.appendChild(s);
		d   = document.createElement('th'); d.innerHTML = 'Date';
			r.appendChild(d);
		th.appendChild(r);

	var tb  = document.createElement('tbody');
		tbl.appendChild(th);
		tbl.appendChild(tb);

//		var tblsrt = tablesort.enable(view.id+'_tbl');
		var tblsrt = tablesort.enable(tbl);
		if(tblsrt)   tablesort.sort({srcElement: n});

		this.reset();
		return true;
	},

	reset: function(){
		var tb = document.getElementById('ReportView');
			tb = document.getElementsByTagName('TBODY')[0];
		var c, a, t, img;

		for(var i in album.imgs){
			img = album.imgs[i];
			var r   = document.createElement('tr'); r.className = 'report_body';
			album.util.addClass(r, (i % 2) ? 'even' : 'odd');

			t   = document.createElement('td');
				c   = document.createElement('img'); c.src = spacer; c.className = 'chkbox'; c.width  = '10'; c.height = '10'; c.id = '_ReportView_cb_'+img['index'];
				t.appendChild(c);
				a   = document.createElement('a'); a.href = '#'; a.id = '_ReportView_'+img['index']; a.innerHTML = img['name'];
					album.util.addEvent(a, 'mousedown', album.util.closure(mousedown, img['index']));
					album.util.addEvent(a, 'dblclick',  album.util.closure(dblclick,  img['index']));
					album.util.addEvent(a, 'mouseover', album.util.closure(this._mouseover, img['index']));
					album.util.addEvent(a, 'mouseout',  album.util.closure(this._mouseout,  img['index']));
				t.appendChild(a);
			r.appendChild(t);

			t = document.createElement('td'); t.innerHTML = img['size']; t.className = 'right';
			r.appendChild(t);

			t = document.createElement('td'); t.innerHTML = img['date'];
			r.appendChild(t);
			tb.appendChild(r);
		}
	},
	selectItem: function(idx, isSelected) {
		var img = album.getimage(idx);
		idx = img["index"];
		var obj = document.getElementById('_ReportView_'+idx);
		if(obj){
			if(isSelected) album.util.addClass(obj, 'selected');
			else           album.util.delClass(obj, 'selected');
		}

		obj = document.getElementById('_ReportView_cb_'+idx);
		if(obj) obj.src = (isSelected) ? check : spacer;
	},

	thumbnail : null,
	_mouseover : function (e, idx){
		if(this.thumbnail) return;

		var elem = e.srcElement || e.target;
		var doc  = elem.ownerDocument;
		var pos  = album.util.getPosition(elem);
		var img  = album.getimage(idx);

		this.thumbnail = doc.createElement('img');
		this.thumbnail.src = img['thumbnail'];
		this.thumbnail.style.position = 'absolute';
		this.thumbnail.style.left = pos.x+60+'px';
		this.thumbnail.style.top  = pos.y+pos.h+1+'px';
		this.thumbnail.style.border = '1px solid black';

		doc.getElementsByTagName('body')[0].appendChild(this.thumbnail);
	},
	_mouseout : function (e, idx){
		if(this.thumbnail == null) return;

		var elem = e.srcElement || e.target;
		elem.ownerDocument.getElementsByTagName('body')[0].removeChild(this.thumbnail);
		this.thumbnail = null;
	}
}
