////////////////////////////////////////////////////////////////////////////////
// Х Javascript
//   ԡХͭ - 
////////////////////////////////////////////////////////////////////////////////

var album = {
	imgs: new Array(),
	add: function (index, name, path, thumbnail, tag, tag_orig, is_image, size, date) {
		var img = new Array();
		img['index'] = index;			// img[0] = index;		
		img['name']  = name;            // img[1] = name;		
		img['path']  = path;            // img[2] = path;		
		img['thumbnail'] = thumbnail;   // img[3] = thumbnail;	
		img['tag'] = tag;               // img[4] = tag;		
		img['tag_orig'] = tag_orig;     // img[5] = tag_orig;	
		img['isImage'] = is_image;      // img[6] = is_image;	
		img['isSelected'] = 0;          // img[7] = '0';		
		img['size'] = size;             // img[8] = size;		
		img['date'] = date;             // img[9] = date;		

		if(this.imgs.length == 0){
			this.imgs.push(img);
			return;
		}

		// 
		var i = 0;
		for( ; i < this.imgs.length; i++){
			if(this._compare_str_asc(''+name, ''+this.imgs[i]['name']))
				continue;
			this.imgs.splice(i, 0, img);
			return;
		}
		this.imgs.push(img);
	},
	_compare_str_asc: function(val1, val2){
		return (val1.toLowerCase() > val2.toLowerCase()) ? 1 : 0;
	},
	getImageList: function(){
		
	},
	getFolderList: function(){
		var obj = http();
		obj.setFeedback(album._updateFolderList);

		var ary = new Array();
		ary['csrf_check_key'] = csrf_check_key;
		ary['action'] = 'ajax';
		ary['query'] = 'getFolderList';
		var q = album.util.ary2query(ary);
		obj.post('./', q);
	},
	_updateFolderList: function(obj){
//		alert('a'+obj+obj._statuscode + obj._response);
	},

	// window size
	_resizeHeight: function () {
		var window_height = document.documentElement.clientHeight;//window height
		var height = 0;
		var obj, style = null;

		if(window_height != undefined){
			// sidebar
			height = window_height - 5;
			obj = document.getElementById('sidebar');
			if(obj && obj.style.display != 'none') height -= (obj.offsetTop+obj.style.paddingTop);
			obj = document.getElementById('ifolderlist1');
			if(obj && obj.style.display != 'none') height -= (obj.clientHeight || obj.offsetHeight);
			obj = document.getElementById('ifolderlist2');
			if(obj && obj.style.display != 'none') height -= (obj.clientHeight || obj.offsetHeight);

			obj = document.getElementById('sidebar')
			if(obj && obj.style.display != 'none') style = album.util.getStyle(obj);
			if(style){
				var t;
				t = style.paddingTop.match(/^\d/);    if(t) height -= parseInt(t);
				t = style.paddingBottom.match(/^\d/); if(t) height -= parseInt(t);
			}
			obj = document.getElementById('folderlist');
			if(obj && height > -2) obj.style.height = height-2 +'px';

			// content
			height = window_height - 15;
			obj = document.getElementById('iimagelist1');
			if(obj && obj.style.display != 'none') height -= (obj.clientHeight || obj.offsetHeight);
			obj = document.getElementById('iimagelist2');
			if(obj && obj.style.display != 'none') height -= (obj.clientHeight || obj.offsetHeight);
			obj = document.getElementById('imagelist');
			if(obj && height > 0) obj.style.height = height+'px';
		}
		return height;
	},
	_resizeWidth: function () {
		var window_width = document.documentElement.clientWidth;
		var width = 0;
		var obj;
		var left = 200;

		if(window_width != undefined){
			width = window_width - 10;
			var sidebar = document.getElementById('sidebar');
			if(sidebar && sidebar.style.display != 'none'){ width -= 200; }
			else                                          { left   = 0; }
			obj = document.getElementById('contents');
			if(obj){
				obj.style.width = width+'px';
				obj.style.left  = left+'px';
			}
			obj = document.getElementById('files');
			if(obj) obj.style.width = width+'px';
		}
		return width;
	},
	resize: function () {
		var height = this._resizeHeight();
		var width  = this._resizeWidth();

		for(var i in album.view.viewlist){
			if(album.view[album.view.viewlist[i]]['resize'])
				album.view[album.view.viewlist[i]]['resize'](width, height);
		}
	},
	showimage: function (idx) {
		win = window.open(this.imgs[idx]['path'], 'popup_albumview', 'location=no, menubar=no, resizable=yes');
		return false;
	},
	_convindex: function (idx) {
		//
		for(var i = 0 ; i <  album.imgs.length; i++){
			if(album.imgs[i]["index"] == idx)
				return i;
		}
		return -1;
	},
	getimage: function (idx) {
		idx = album._convindex(idx);
		if(idx == -1)
			return null;
		return album.imgs[idx];
	},
	replaceinfo: function (idx) {
		var img = album.getimage(idx);
		var obj = document.getElementById('fileinfo');
		album.util.clearChilden(obj);

		var a = document.createElement('a');
		a.id = 'filename';
		a.innerHTML = img['name'] + ' ('+ img['size'] +' bytes)';
		a.href = img['path'];
		obj.appendChild(a);
		return false;
	},
	_setinfo: function (str, href) {
		var obj = document.getElementById('filename');
		obj.innerHTML = str;
		obj.href = href;
	}
};

////////////////////////////////////////////////////////////////////////////////
// ӥ塼
////////////////////////////////////////////////////////////////////////////////
album.view = {
	viewnum: 0,
	viewlist: new Array(),
	currentview: null,

	////////////////////////////////////////
	// ڤؤ
	switch_view: function (){
		if(this.viewlist.length == 0) return; // error: there is no view;

		var view, i;
		for(i = 0; this.viewlist.length; i++){
			if(this.viewlist[i] == this.currentview.id)
				break;
		}
		this.select_view(this.viewlist[i+1]);
	},
	select_view: function (view){
		if(view == undefined || view == null || view == '') return;

		var oldviewid = null;
		var nextview = document.getElementById(view);
		if(nextview && (nextview != this.currentview)){
			if(this.currentview){
				if(this[this.currentview.id]['hide'])
					this[this.currentview.id]['hide'](nextview.id);

				oldviewid = this.currentview.id;
				this.currentview.style.display = 'none';
			}
			nextview.style.display = 'block';
			this.currentview = nextview;

			if(this[this.currentview.id]['show'])
				this[this.currentview.id]['show'](oldviewid);
		}
	},

	////////////////////////////////////////
	// 
	make_view: function() {
		var content = document.getElementById('imagelist');

		var view;
		for(var i in this){
			if(/^(.*View)$/.test(i)){
				view = document.createElement('div'); 
				view.style.display = 'none';
				view.id = RegExp.$1;
				this.viewnum++;
				content.appendChild(view);

				this[i]['create'](view);
				this.viewlist.push(view.id);
			}
		}
		this.viewlist.push(this.viewlist[0]);
		this.select_view(this.viewlist[0]);
	}
};

album.util = {
	clearChilden: function(node){
		if(!node) return false;
		while(node.firstChild)
			node.removeChild(node.firstChild);
		return true;
	},
	isIE : /*@cc_on ! @*/ false,
	preventDefault : function (ev){
		if(this.isIE)  ev.returnValue = false;
		else           ev.preventDefault();
	},
	stopPropagation : function (ev){
		if(this.isIE)  ev.cancelBubble = true;
		else           ev.stopPropagation();
	},
	addEvent : function (obj, name, func) {
		if(obj == undefined || name == '' || func == undefined) return false;
		if(obj.addEventListener) obj.addEventListener(name, func, false);
		else if(obj.attachEvent) obj.attachEvent('on'+name, func);
		else return false;// setAttribute('on'+name, func);

		return true;
	},
	delEvent : function (obj, name, func) {
		if(obj == undefined || name == '' || func == undefined) return false;
		if(obj.removeEventListener) obj.removeEventListener(name, func, false);
		else if(obj.detachEvent)    obj.detachEvent('on'+name, func);
		else return false;// setAttribute('on'+name, '');

		return true;
	},
	getStyle: function(obj) {
		if(obj == document) return null;
		return obj.currentStyle || document.defaultView.getComputedStyle(obj, '');
	},
	closure : function (func, x) {
		return function(e) { func(e, x) };
	},
	getPosition: function (obj){
		if(obj == undefined)
			return null;

		var height = obj.offsetHeight || obj.clientHeight;
		var width  = obj.offsetWidth  || obj.clientWidth;

		var style;
		var curX = 0;
		var curY = 0;
		var parent = obj;
		while (parent) {
			curX += parent.offsetLeft;
			curY += parent.offsetTop;
			style = this.getStyle(parent);
			if(style.position == 'absolute' || style.position == 'relative')
				break;
			parent = parent.offsetParent;
		}

		parent = obj;
		while (parent && parent != parent.parentNode && parent != document) {
			curX -= (parent.scrollLeft || 0);
			curY -= (parent.scrollTop  || 0);
			style = this.getStyle(parent);
			if(style.position == 'absolute' || style.position == 'relative')
				break;
			parent = parent.parentNode;
		}

	    return {x:curX,y:curY,w:width,h:height};
	},
    hasClass: function (obj, name) {
		if(!obj || !obj.className) return false;

		var classes;
		classes = obj.className.split(' ');
		var found = false;
		for(var i in classes){
			if(classes[i] == name){
				found = true;
				break;
			}
		}
		return found;
	},
	addClass : function (obj, name) {
		if(!obj) return false;

		var classes = obj.className.split(' ');
		var found = false;
		for(var i in classes){
			if(classes[i] == name){
				found = true;
				break;
			}
		}
		if(!found)
			classes.push(name);

		obj.className = classes.join(' ');
		return true;
	},
	delClass : function (obj, name) {
		if(!obj) return false;

		var classes = obj.className.split(' ');
		for(var i in classes){
			if(classes[i] == name){
				classes[i] = '';
				break;
			}
		}

		obj.className = classes.join(' ');
		return true;
	},
	ary2query: function(ary){
		var q;
		for(var i in ary){
			q += i;
			if(ary[i])
				q += '='+ary[i];
		}
		return q;
	}
}

////////////////////////////////////////////////////////////////////////////////
// 󥿡ե
////////////////////////////////////////////////////////////////////////////////
function closeBlock(tName){
	var tImg       = document.getElementById('img_' + tName);
	var tBlock     = document.getElementById('blk_' + tName);
	tImg.src       = plusicon;
	tBlock.style.display = 'none';
	album.resize();
}
function openBlock(tName){
	var tImg       = document.getElementById('img_' + tName);
	var tBlock     = document.getElementById('blk_' + tName);
	tImg.src       = minusicon;
	tBlock.style.display = 'block';
	album.resize();
}
function toggleBlock(tName){
	var tBlock     = document.getElementById('blk_' + tName);
	if(tBlock.style.display=='none') openBlock(tName);
	else                             closeBlock(tName);
	return false;
}
